"use strict";
// tslint:disable
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var superagent = require("superagent");
var moment = require("moment");
var HiveMPError = /** @class */ (function (_super) {
    __extends(HiveMPError, _super);
    function HiveMPError() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._hiveMPErrorType = '';
        return _this;
    }
    return HiveMPError;
}(Error));
exports.HiveMPError = HiveMPError;
var HiveMPErrorFactory = /** @class */ (function () {
    function HiveMPErrorFactory() {
    }
    // ======== redirect errors =========
    HiveMPErrorFactory.createRedirectError = function (redirectTarget) {
        var err = new HiveMPError('Internal server-side redirect');
        err._hiveMPErrorType = 'redirect';
        err.redirectTarget = redirectTarget;
        return err;
    };
    HiveMPErrorFactory.isRedirectError = function (err) {
        return err._hiveMPErrorType == 'redirect' && err.redirectTarget != undefined;
    };
    HiveMPErrorFactory.getRedirectErrorRedirect = function (err) {
        if (err._hiveMPErrorType == 'redirect' && err.redirectTarget != undefined) {
            return err.redirectTarget;
        }
        throw new Error('Invalid use of getRedirectErrorRedirect');
    };
    // ======== API errors =========
    HiveMPErrorFactory.createApiError = function (apiError) {
        var suffix = apiError.fields == null ? '' : (' (' + apiError.fields + ')');
        var err = new HiveMPError('#' + apiError.code + ': ' + apiError.message + suffix);
        err._hiveMPErrorType = 'api-error';
        err.apiError = apiError;
        return err;
    };
    HiveMPErrorFactory.isApiError = function (err) {
        if (err === "Can't read from server.  It may not have the appropriate access-control-origin settings.") {
            // Timeout or unreachable.
            return true;
        }
        return err._hiveMPErrorType == 'api-error' && err.apiError != undefined;
    };
    HiveMPErrorFactory.getApiErrorData = function (err) {
        if (err === "Can't read from server.  It may not have the appropriate access-control-origin settings.") {
            // Timeout or unreachable.
            return {
                code: 0,
                message: err,
                fields: null,
                isTimeout: true,
                data: {},
            };
        }
        if (err._hiveMPErrorType == 'api-error' && err.apiError != undefined) {
            return __assign({}, err.apiError, { isTimeout: false });
        }
        throw new Error('Invalid use of getApiErrorData');
    };
    // ======== session expiry errors =========
    HiveMPErrorFactory.createSessionExpiredError = function () {
        var err = new HiveMPError('Session expired; redirecting to login page');
        err._hiveMPErrorType = 'session-expired';
        return err;
    };
    HiveMPErrorFactory.isSessionExpiredError = function (err) {
        return err._hiveMPErrorType == 'session-expired';
    };
    // ======== client response errors =========
    HiveMPErrorFactory.createClientError = function (response) {
        var err = new HiveMPError('Unexpected response status ' + response.status + '. Are you offline?');
        err._hiveMPErrorType = 'client-error';
        return err;
    };
    HiveMPErrorFactory.isClientError = function (err) {
        return err._hiveMPErrorType == 'client-error';
    };
    // ======== unknown errors =========
    HiveMPErrorFactory.createUnknownError = function (nestedErr) {
        var err = new HiveMPError('Unknown error occurred during request. Are you offline?');
        err._hiveMPErrorType = 'unknown-error';
        err.nestedErr = nestedErr;
        return err;
    };
    HiveMPErrorFactory.isUnknownError = function (err) {
        return err._hiveMPErrorType == 'unknown-error';
    };
    return HiveMPErrorFactory;
}());
exports.HiveMPErrorFactory = HiveMPErrorFactory;
;
function reviveValue(key, value) {
    if (key.endsWith("Utc") && typeof value === 'number') {
        // This is a timestamp value. Restore it with moment.
        return moment.unix(value);
    }
    return value;
}
function replaceValue(key, value) {
    if (key.endsWith("Utc") && moment.isMoment(value)) {
        // This is a timestamp value. Convert it back to UNIX UTC timestamp.
        return value.unix();
    }
    return value;
}
var AdministrativeSession;
(function (AdministrativeSession) {
    var AdministrationSessionClient = /** @class */ (function () {
        function AdministrationSessionClient(apiKey) {
            this.getOriginalApiId = function () { return "admin-session"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://admin-session-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        AdministrationSessionClient.prototype.sessionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AdministrationSessionClient.prototype.__sessionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_1 = _a.sent();
                            nestedErr = err_1;
                            response = err_1.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AdministrationSessionClient.prototype.sessionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AdministrationSessionClient.prototype.__sessionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["username"] = req.username;
                            qs["password"] = req.password;
                            if (req.project !== undefined) {
                                qs["project"] = req.project;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_2 = _a.sent();
                            nestedErr = err_2;
                            response = err_2.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AdministrationSessionClient.prototype.sessionPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AdministrationSessionClient.prototype.__sessionPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_3;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_3 = _a.sent();
                            nestedErr = err_3;
                            response = err_3.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AdministrationSessionClient.prototype.sessionDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AdministrationSessionClient.prototype.__sessionDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_4;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_4 = _a.sent();
                            nestedErr = err_4;
                            response = err_4.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AdministrationSessionClient.prototype.switchPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__switchPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__switchPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AdministrationSessionClient.prototype.__switchPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_5;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/switch')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_5 = _a.sent();
                            nestedErr = err_5;
                            response = err_5.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return AdministrationSessionClient;
    }());
    AdministrativeSession.AdministrationSessionClient = AdministrationSessionClient;
    var AdministrationUserClient = /** @class */ (function () {
        function AdministrationUserClient(apiKey) {
            this.getOriginalApiId = function () { return "admin-session"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://admin-session-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        AdministrationUserClient.prototype.userGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__userGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__userGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AdministrationUserClient.prototype.__userGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_6;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/user')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.username !== undefined) {
                                qs["username"] = req.username;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_6 = _a.sent();
                            nestedErr = err_6;
                            response = err_6.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AdministrationUserClient.prototype.userPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__userPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__userPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AdministrationUserClient.prototype.__userPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_7;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/user')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["username"] = req.username;
                            qs["password"] = req.password;
                            qs["email"] = req.email;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_7 = _a.sent();
                            nestedErr = err_7;
                            response = err_7.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AdministrationUserClient.prototype.verifyPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__verifyPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__verifyPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AdministrationUserClient.prototype.__verifyPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_8;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/verify')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.username !== undefined) {
                                qs["username"] = req.username;
                            }
                            if (req.code !== undefined) {
                                qs["code"] = req.code;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_8 = _a.sent();
                            nestedErr = err_8;
                            response = err_8.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return AdministrationUserClient;
    }());
    AdministrativeSession.AdministrationUserClient = AdministrationUserClient;
    var NewsClient = /** @class */ (function () {
        function NewsClient(apiKey) {
            this.getOriginalApiId = function () { return "admin-session"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://admin-session-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        NewsClient.prototype.newsRecentGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__newsRecentGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__newsRecentGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        NewsClient.prototype.__newsRecentGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_9;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/news/recent')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_9 = _a.sent();
                            nestedErr = err_9;
                            response = err_9.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return NewsClient;
    }());
    AdministrativeSession.NewsClient = NewsClient;
    var ProjectInfoClient = /** @class */ (function () {
        function ProjectInfoClient(apiKey) {
            this.getOriginalApiId = function () { return "admin-session"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://admin-session-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        ProjectInfoClient.prototype.projectsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__projectsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__projectsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.__projectsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_10;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/projects')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_10 = _a.sent();
                            nestedErr = err_10;
                            response = err_10.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.projectGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__projectGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__projectGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.__projectGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_11;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/project')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_11 = _a.sent();
                            nestedErr = err_11;
                            response = err_11.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.projectPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__projectPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__projectPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.__projectPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_12;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/project')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["name"] = req.name;
                            if (req.discoverable !== undefined) {
                                qs["discoverable"] = req.discoverable ? "true" : "false";
                            }
                            if (req.isTestProject !== undefined) {
                                qs["isTestProject"] = req.isTestProject ? "true" : "false";
                            }
                            if (req.publicName !== undefined) {
                                qs["publicName"] = req.publicName;
                            }
                            if (req.shortDescription !== undefined) {
                                qs["shortDescription"] = req.shortDescription;
                            }
                            if (req.developerName !== undefined) {
                                qs["developerName"] = req.developerName;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_12 = _a.sent();
                            nestedErr = err_12;
                            response = err_12.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.projectPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__projectPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__projectPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.__projectPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_13;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/project')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.active !== undefined) {
                                qs["active"] = req.active ? "true" : "false";
                            }
                            if (req.discoverable !== undefined) {
                                qs["discoverable"] = req.discoverable ? "true" : "false";
                            }
                            if (req.publicName !== undefined) {
                                qs["publicName"] = req.publicName;
                            }
                            if (req.websiteUrl !== undefined) {
                                qs["websiteUrl"] = req.websiteUrl;
                            }
                            if (req.shortDescription !== undefined) {
                                qs["shortDescription"] = req.shortDescription;
                            }
                            if (req.developerName !== undefined) {
                                qs["developerName"] = req.developerName;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_13 = _a.sent();
                            nestedErr = err_13;
                            response = err_13.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.projectBannerPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__projectBannerPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__projectBannerPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.__projectBannerPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_14;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/project/banner')
                                .set('Content-Type', 'application/octet-stream');
                            qs = {};
                            qs["id"] = req.id;
                            request.send(req.content);
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_14 = _a.sent();
                            nestedErr = err_14;
                            response = err_14.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.projectAvatarPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__projectAvatarPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__projectAvatarPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.__projectAvatarPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_15;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/project/avatar')
                                .set('Content-Type', 'application/octet-stream');
                            qs = {};
                            qs["id"] = req.id;
                            request.send(req.content);
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_15 = _a.sent();
                            nestedErr = err_15;
                            response = err_15.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.projectPublicGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__projectPublicGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__projectPublicGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.__projectPublicGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_16;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/project/public')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_16 = _a.sent();
                            nestedErr = err_16;
                            response = err_16.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.projectsPublicGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__projectsPublicGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__projectsPublicGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.__projectsPublicGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_17;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/projects/public')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.ids, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_17 = _a.sent();
                            nestedErr = err_17;
                            response = err_17.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.accessGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accessGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accessGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.__accessGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_18;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/access')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_18 = _a.sent();
                            nestedErr = err_18;
                            response = err_18.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.accessUserPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accessUserPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accessUserPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.__accessUserPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_19;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/access/user')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            qs["username"] = req.username;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_19 = _a.sent();
                            nestedErr = err_19;
                            response = err_19.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.accessUserDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accessUserDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accessUserDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.__accessUserDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_20;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/access/user')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            qs["username"] = req.username;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_20 = _a.sent();
                            nestedErr = err_20;
                            response = err_20.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.accessProjectPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accessProjectPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accessProjectPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.__accessProjectPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_21;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/access/project')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            qs["projectId"] = req.projectId;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_21 = _a.sent();
                            nestedErr = err_21;
                            response = err_21.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.accessProjectDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accessProjectDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accessProjectDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectInfoClient.prototype.__accessProjectDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_22;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/access/project')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            qs["projectId"] = req.projectId;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_22 = _a.sent();
                            nestedErr = err_22;
                            response = err_22.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return ProjectInfoClient;
    }());
    AdministrativeSession.ProjectInfoClient = ProjectInfoClient;
})(AdministrativeSession = exports.AdministrativeSession || (exports.AdministrativeSession = {}));
var ApiKey;
(function (ApiKey) {
    var KeyClient = /** @class */ (function () {
        function KeyClient(apiKey) {
            this.getOriginalApiId = function () { return "api-key"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://api-key-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        KeyClient.prototype.keysGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keysGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keysGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        KeyClient.prototype.__keysGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_23;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/keys')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            qs["type"] = req.type;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_23 = _a.sent();
                            nestedErr = err_23;
                            response = err_23.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        KeyClient.prototype.keysAdminUserGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keysAdminUserGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keysAdminUserGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        KeyClient.prototype.__keysAdminUserGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_24;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/keys/adminUser')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            qs["username"] = req.username;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_24 = _a.sent();
                            nestedErr = err_24;
                            response = err_24.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        KeyClient.prototype.keysAccountGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keysAccountGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keysAccountGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        KeyClient.prototype.__keysAccountGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_25;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/keys/account')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            qs["accountId"] = req.accountId;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_25 = _a.sent();
                            nestedErr = err_25;
                            response = err_25.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        KeyClient.prototype.keyGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keyGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keyGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        KeyClient.prototype.__keyGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_26;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/key')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["apiKeyHash"] = req.apiKeyHash;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_26 = _a.sent();
                            nestedErr = err_26;
                            response = err_26.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        KeyClient.prototype.keyPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keyPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keyPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        KeyClient.prototype.__keyPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_27;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/key')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["apiKeyHash"] = req.apiKeyHash;
                            if (req.comment !== undefined) {
                                qs["comment"] = req.comment;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_27 = _a.sent();
                            nestedErr = err_27;
                            response = err_27.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        KeyClient.prototype.keyDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keyDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keyDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        KeyClient.prototype.__keyDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_28;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/key')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["apiKeyHash"] = req.apiKeyHash;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_28 = _a.sent();
                            nestedErr = err_28;
                            response = err_28.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        KeyClient.prototype.revealPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__revealPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__revealPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        KeyClient.prototype.__revealPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_29;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/reveal')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["apiKeyHash"] = req.apiKeyHash;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_29 = _a.sent();
                            nestedErr = err_29;
                            response = err_29.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        KeyClient.prototype.keyPublicPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keyPublicPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keyPublicPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        KeyClient.prototype.__keyPublicPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_30;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/key/public')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.comment !== undefined) {
                                qs["comment"] = req.comment;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_30 = _a.sent();
                            nestedErr = err_30;
                            response = err_30.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return KeyClient;
    }());
    ApiKey.KeyClient = KeyClient;
})(ApiKey = exports.ApiKey || (exports.ApiKey = {}));
var Chat;
(function (Chat) {
    var ChatClient = /** @class */ (function () {
        function ChatClient(apiKey) {
            this.getOriginalApiId = function () { return "chat"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://chat-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        ChatClient.prototype.chatConnectGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__chatConnectGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__chatConnectGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ChatClient.prototype.__chatConnectGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_31;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/chat/connect')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_31 = _a.sent();
                            nestedErr = err_31;
                            response = err_31.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return ChatClient;
    }());
    Chat.ChatClient = ChatClient;
})(Chat = exports.Chat || (exports.Chat = {}));
var EventTracking;
(function (EventTracking) {
    var EventClient = /** @class */ (function () {
        function EventClient(apiKey) {
            this.getOriginalApiId = function () { return "event"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://event-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        EventClient.prototype.eventInsertPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__eventInsertPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__eventInsertPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventClient.prototype.__eventInsertPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_32;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/event/insert')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.eventType !== undefined) {
                                qs["eventType"] = req.eventType;
                            }
                            if (req.eventTypeVersion !== undefined) {
                                qs["eventTypeVersion"] = req.eventTypeVersion;
                            }
                            request.send(JSON.stringify(req.event, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_32 = _a.sent();
                            nestedErr = err_32;
                            response = err_32.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        EventClient.prototype.eventBatchInsertPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__eventBatchInsertPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__eventBatchInsertPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventClient.prototype.__eventBatchInsertPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_33;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/event/batchInsert')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.eventType !== undefined) {
                                qs["eventType"] = req.eventType;
                            }
                            if (req.eventTypeVersion !== undefined) {
                                qs["eventTypeVersion"] = req.eventTypeVersion;
                            }
                            request.send(JSON.stringify(req.events, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_33 = _a.sent();
                            nestedErr = err_33;
                            response = err_33.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return EventClient;
    }());
    EventTracking.EventClient = EventClient;
    var EventTypesClient = /** @class */ (function () {
        function EventTypesClient(apiKey) {
            this.getOriginalApiId = function () { return "event"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://event-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        EventTypesClient.prototype.typesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__typesGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__typesGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventTypesClient.prototype.__typesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_34;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/types')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_34 = _a.sent();
                            nestedErr = err_34;
                            response = err_34.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        EventTypesClient.prototype.typeGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__typeGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__typeGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventTypesClient.prototype.__typeGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_35;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/type')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_35 = _a.sent();
                            nestedErr = err_35;
                            response = err_35.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        EventTypesClient.prototype.typePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__typePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__typePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventTypesClient.prototype.__typePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_36;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/type')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.eventType, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_36 = _a.sent();
                            nestedErr = err_36;
                            response = err_36.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        EventTypesClient.prototype.typePOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__typePOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__typePOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventTypesClient.prototype.__typePOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_37;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/type')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.eventType, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_37 = _a.sent();
                            nestedErr = err_37;
                            response = err_37.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        EventTypesClient.prototype.typeVersionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__typeVersionsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__typeVersionsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventTypesClient.prototype.__typeVersionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_38;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/type/versions')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_38 = _a.sent();
                            nestedErr = err_38;
                            response = err_38.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        EventTypesClient.prototype.typeVersionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__typeVersionGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__typeVersionGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventTypesClient.prototype.__typeVersionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_39;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/type/version')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            qs["version"] = req.version;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_39 = _a.sent();
                            nestedErr = err_39;
                            response = err_39.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        EventTypesClient.prototype.typeVersionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__typeVersionPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__typeVersionPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventTypesClient.prototype.__typeVersionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_40;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/type/version')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.eventTypeVersion, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_40 = _a.sent();
                            nestedErr = err_40;
                            response = err_40.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        EventTypesClient.prototype.typeVersionPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__typeVersionPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__typeVersionPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventTypesClient.prototype.__typeVersionPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_41;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/type/version')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.eventTypeVersion, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_41 = _a.sent();
                            nestedErr = err_41;
                            response = err_41.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return EventTypesClient;
    }());
    EventTracking.EventTypesClient = EventTypesClient;
})(EventTracking = exports.EventTracking || (exports.EventTracking = {}));
var Scheduling;
(function (Scheduling) {
    var SchedulingClient = /** @class */ (function () {
        function SchedulingClient(apiKey) {
            this.getOriginalApiId = function () { return "scheduling"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://scheduling-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        SchedulingClient.prototype.schedulePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__schedulePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__schedulePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        SchedulingClient.prototype.__schedulePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_42;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/schedule')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.scheduleUtc !== undefined) {
                                qs["scheduleUtc"] = req.scheduleUtc.unix().toString();
                            }
                            if (req.callbackUrl !== undefined) {
                                qs["callbackUrl"] = req.callbackUrl;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_42 = _a.sent();
                            nestedErr = err_42;
                            response = err_42.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return SchedulingClient;
    }());
    Scheduling.SchedulingClient = SchedulingClient;
})(Scheduling = exports.Scheduling || (exports.Scheduling = {}));
var Lobby;
(function (Lobby) {
    var LobbyClient = /** @class */ (function () {
        function LobbyClient(apiKey) {
            this.getOriginalApiId = function () { return "lobby"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://lobby-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        LobbyClient.prototype.lobbiesPaginatedGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__lobbiesPaginatedGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__lobbiesPaginatedGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LobbyClient.prototype.__lobbiesPaginatedGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_43;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/lobbies/paginated')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_43 = _a.sent();
                            nestedErr = err_43;
                            response = err_43.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LobbyClient.prototype.lobbiesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__lobbiesGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__lobbiesGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LobbyClient.prototype.__lobbiesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_44;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/lobbies')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_44 = _a.sent();
                            nestedErr = err_44;
                            response = err_44.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LobbyClient.prototype.lobbyGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__lobbyGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__lobbyGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LobbyClient.prototype.__lobbyGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_45;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/lobby')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_45 = _a.sent();
                            nestedErr = err_45;
                            response = err_45.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LobbyClient.prototype.lobbyPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__lobbyPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__lobbyPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LobbyClient.prototype.__lobbyPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_46;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/lobby')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.maxSessions !== undefined) {
                                qs["maxSessions"] = req.maxSessions.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_46 = _a.sent();
                            nestedErr = err_46;
                            response = err_46.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LobbyClient.prototype.lobbyPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__lobbyPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__lobbyPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LobbyClient.prototype.__lobbyPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_47;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/lobby')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.maxSessions !== undefined) {
                                qs["maxSessions"] = req.maxSessions.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_47 = _a.sent();
                            nestedErr = err_47;
                            response = err_47.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LobbyClient.prototype.lobbyDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__lobbyDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__lobbyDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LobbyClient.prototype.__lobbyDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_48;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/lobby')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_48 = _a.sent();
                            nestedErr = err_48;
                            response = err_48.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LobbyClient.prototype.sessionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LobbyClient.prototype.__sessionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_49;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/sessions')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_49 = _a.sent();
                            nestedErr = err_49;
                            response = err_49.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LobbyClient.prototype.sessionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LobbyClient.prototype.__sessionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_50;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.lobbyId !== undefined) {
                                qs["lobbyId"] = req.lobbyId;
                            }
                            if (req.sessionId !== undefined) {
                                qs["sessionId"] = req.sessionId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_50 = _a.sent();
                            nestedErr = err_50;
                            response = err_50.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LobbyClient.prototype.sessionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LobbyClient.prototype.__sessionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_51;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.lobbyId !== undefined) {
                                qs["lobbyId"] = req.lobbyId;
                            }
                            if (req.sessionId !== undefined) {
                                qs["sessionId"] = req.sessionId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_51 = _a.sent();
                            nestedErr = err_51;
                            response = err_51.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LobbyClient.prototype.sessionDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LobbyClient.prototype.__sessionDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_52;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.lobbyId !== undefined) {
                                qs["lobbyId"] = req.lobbyId;
                            }
                            if (req.sessionId !== undefined) {
                                qs["sessionId"] = req.sessionId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_52 = _a.sent();
                            nestedErr = err_52;
                            response = err_52.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return LobbyClient;
    }());
    Lobby.LobbyClient = LobbyClient;
})(Lobby = exports.Lobby || (exports.Lobby = {}));
var TemporarySession;
(function (TemporarySession) {
    var TemporarySessionClient = /** @class */ (function () {
        function TemporarySessionClient(apiKey) {
            this.getOriginalApiId = function () { return "temp-session"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://temp-session-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        TemporarySessionClient.prototype.sessionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        TemporarySessionClient.prototype.__sessionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_53;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_53 = _a.sent();
                            nestedErr = err_53;
                            response = err_53.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        TemporarySessionClient.prototype.sessionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        TemporarySessionClient.prototype.__sessionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_54;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_54 = _a.sent();
                            nestedErr = err_54;
                            response = err_54.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        TemporarySessionClient.prototype.sessionPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        TemporarySessionClient.prototype.__sessionPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_55;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_55 = _a.sent();
                            nestedErr = err_55;
                            response = err_55.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        TemporarySessionClient.prototype.sessionDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        TemporarySessionClient.prototype.__sessionDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_56;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_56 = _a.sent();
                            nestedErr = err_56;
                            response = err_56.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return TemporarySessionClient;
    }());
    TemporarySession.TemporarySessionClient = TemporarySessionClient;
    var TemporarySessionAdminClient = /** @class */ (function () {
        function TemporarySessionAdminClient(apiKey) {
            this.getOriginalApiId = function () { return "temp-session"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://temp-session-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        TemporarySessionAdminClient.prototype.sessionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        TemporarySessionAdminClient.prototype.__sessionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_57;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/sessions')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_57 = _a.sent();
                            nestedErr = err_57;
                            response = err_57.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return TemporarySessionAdminClient;
    }());
    TemporarySession.TemporarySessionAdminClient = TemporarySessionAdminClient;
})(TemporarySession = exports.TemporarySession || (exports.TemporarySession = {}));
var UserSession;
(function (UserSession) {
    var DigitalLicenseClient = /** @class */ (function () {
        function DigitalLicenseClient(apiKey) {
            this.getOriginalApiId = function () { return "user-session"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://user-session-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        DigitalLicenseClient.prototype.digitalLicenseGrantPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__digitalLicenseGrantPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__digitalLicenseGrantPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        DigitalLicenseClient.prototype.__digitalLicenseGrantPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_58;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/digitalLicense/grant')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["accountId"] = req.accountId;
                            qs["productId"] = req.productId;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_58 = _a.sent();
                            nestedErr = err_58;
                            response = err_58.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        DigitalLicenseClient.prototype.digitalLicenseRevokeDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__digitalLicenseRevokeDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__digitalLicenseRevokeDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        DigitalLicenseClient.prototype.__digitalLicenseRevokeDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_59;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/digitalLicense/revoke')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["accountId"] = req.accountId;
                            qs["productId"] = req.productId;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_59 = _a.sent();
                            nestedErr = err_59;
                            response = err_59.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        DigitalLicenseClient.prototype.digitalLicenseValidateGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__digitalLicenseValidateGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__digitalLicenseValidateGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        DigitalLicenseClient.prototype.__digitalLicenseValidateGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_60;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/digitalLicense/validate')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["productId"] = req.productId;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_60 = _a.sent();
                            nestedErr = err_60;
                            response = err_60.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        DigitalLicenseClient.prototype.digitalLicensesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__digitalLicensesGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__digitalLicensesGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        DigitalLicenseClient.prototype.__digitalLicensesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_61;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/digitalLicenses')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_61 = _a.sent();
                            nestedErr = err_61;
                            response = err_61.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return DigitalLicenseClient;
    }());
    UserSession.DigitalLicenseClient = DigitalLicenseClient;
    var FriendClient = /** @class */ (function () {
        function FriendClient(apiKey) {
            this.getOriginalApiId = function () { return "user-session"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://user-session-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        FriendClient.prototype.friendsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__friendsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__friendsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        FriendClient.prototype.__friendsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_62;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/friends')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_62 = _a.sent();
                            nestedErr = err_62;
                            response = err_62.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        FriendClient.prototype.friendRequestsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__friendRequestsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__friendRequestsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        FriendClient.prototype.__friendRequestsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_63;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/friendRequests')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_63 = _a.sent();
                            nestedErr = err_63;
                            response = err_63.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        FriendClient.prototype.friendRequestsSentGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__friendRequestsSentGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__friendRequestsSentGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        FriendClient.prototype.__friendRequestsSentGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_64;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/friendRequestsSent')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_64 = _a.sent();
                            nestedErr = err_64;
                            response = err_64.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        FriendClient.prototype.friendRequestsSendPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__friendRequestsSendPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__friendRequestsSendPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        FriendClient.prototype.__friendRequestsSendPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_65;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/friendRequests/send')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            qs["sendQuery"] = req.sendQuery;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_65 = _a.sent();
                            nestedErr = err_65;
                            response = err_65.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        FriendClient.prototype.friendRequestsRescindDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__friendRequestsRescindDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__friendRequestsRescindDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        FriendClient.prototype.__friendRequestsRescindDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_66;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/friendRequests/rescind')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            qs["targetId"] = req.targetId;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_66 = _a.sent();
                            nestedErr = err_66;
                            response = err_66.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        FriendClient.prototype.friendRequestsAcceptPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__friendRequestsAcceptPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__friendRequestsAcceptPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        FriendClient.prototype.__friendRequestsAcceptPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_67;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/friendRequests/accept')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            qs["targetId"] = req.targetId;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_67 = _a.sent();
                            nestedErr = err_67;
                            response = err_67.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        FriendClient.prototype.friendRequestsRejectDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__friendRequestsRejectDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__friendRequestsRejectDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        FriendClient.prototype.__friendRequestsRejectDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_68;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/friendRequests/reject')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            qs["targetId"] = req.targetId;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_68 = _a.sent();
                            nestedErr = err_68;
                            response = err_68.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return FriendClient;
    }());
    UserSession.FriendClient = FriendClient;
    var LocationClient = /** @class */ (function () {
        function LocationClient(apiKey) {
            this.getOriginalApiId = function () { return "user-session"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://user-session-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        LocationClient.prototype.locationCountryNamesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__locationCountryNamesGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__locationCountryNamesGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LocationClient.prototype.__locationCountryNamesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_69;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/location/countryNames')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_69 = _a.sent();
                            nestedErr = err_69;
                            response = err_69.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LocationClient.prototype.locationStateNamesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__locationStateNamesGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__locationStateNamesGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LocationClient.prototype.__locationStateNamesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_70;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/location/stateNames')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["country"] = req.country;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_70 = _a.sent();
                            nestedErr = err_70;
                            response = err_70.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LocationClient.prototype.locationCityNamesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__locationCityNamesGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__locationCityNamesGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LocationClient.prototype.__locationCityNamesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_71;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/location/cityNames')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["country"] = req.country;
                            qs["state"] = req.state;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_71 = _a.sent();
                            nestedErr = err_71;
                            response = err_71.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LocationClient.prototype.locationGeocodeGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__locationGeocodeGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__locationGeocodeGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LocationClient.prototype.__locationGeocodeGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_72;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/location/geocode')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["country"] = req.country;
                            if (req.state !== undefined) {
                                qs["state"] = req.state;
                            }
                            if (req.city !== undefined) {
                                qs["city"] = req.city;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_72 = _a.sent();
                            nestedErr = err_72;
                            response = err_72.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return LocationClient;
    }());
    UserSession.LocationClient = LocationClient;
    var OAuthClientClient = /** @class */ (function () {
        function OAuthClientClient(apiKey) {
            this.getOriginalApiId = function () { return "user-session"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://user-session-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        OAuthClientClient.prototype.flowSessionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__flowSessionPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__flowSessionPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        OAuthClientClient.prototype.__flowSessionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_73;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/flowSession')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["destinationUrl"] = req.destinationUrl;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_73 = _a.sent();
                            nestedErr = err_73;
                            response = err_73.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        OAuthClientClient.prototype.providersGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__providersGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__providersGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        OAuthClientClient.prototype.__providersGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_74;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/providers')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_74 = _a.sent();
                            nestedErr = err_74;
                            response = err_74.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        OAuthClientClient.prototype.flowSessionStatusGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__flowSessionStatusGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__flowSessionStatusGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        OAuthClientClient.prototype.__flowSessionStatusGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_75;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/flowSession/status')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["sessionToken"] = req.sessionToken;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_75 = _a.sent();
                            nestedErr = err_75;
                            response = err_75.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        OAuthClientClient.prototype.startingUrlGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__startingUrlGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__startingUrlGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        OAuthClientClient.prototype.__startingUrlGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_76;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/startingUrl')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["provider"] = req.provider;
                            qs["sessionToken"] = req.sessionToken;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_76 = _a.sent();
                            nestedErr = err_76;
                            response = err_76.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        OAuthClientClient.prototype.receivePlatformGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__receivePlatformGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__receivePlatformGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        OAuthClientClient.prototype.__receivePlatformGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_77;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/receive/{platform}')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_77 = _a.sent();
                            nestedErr = err_77;
                            response = err_77.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return OAuthClientClient;
    }());
    UserSession.OAuthClientClient = OAuthClientClient;
    var RoleAccessClient = /** @class */ (function () {
        function RoleAccessClient(apiKey) {
            this.getOriginalApiId = function () { return "user-session"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://user-session-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        RoleAccessClient.prototype.roleAccessGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__roleAccessGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__roleAccessGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RoleAccessClient.prototype.__roleAccessGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_78;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/role/access')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_78 = _a.sent();
                            nestedErr = err_78;
                            response = err_78.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RoleAccessClient.prototype.roleAccessPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__roleAccessPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__roleAccessPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RoleAccessClient.prototype.__roleAccessPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_79;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/role/access')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.grant, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_79 = _a.sent();
                            nestedErr = err_79;
                            response = err_79.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RoleAccessClient.prototype.roleAccessDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__roleAccessDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__roleAccessDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RoleAccessClient.prototype.__roleAccessDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_80;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/role/access')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.sourceId !== undefined) {
                                qs["sourceId"] = req.sourceId;
                            }
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_80 = _a.sent();
                            nestedErr = err_80;
                            response = err_80.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return RoleAccessClient;
    }());
    UserSession.RoleAccessClient = RoleAccessClient;
    var UserAccountClient = /** @class */ (function () {
        function UserAccountClient(apiKey) {
            this.getOriginalApiId = function () { return "user-session"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://user-session-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        UserAccountClient.prototype.profileAvatarPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__profileAvatarPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__profileAvatarPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserAccountClient.prototype.__profileAvatarPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_81;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/profile/avatar')
                                .set('Content-Type', 'application/octet-stream');
                            qs = {};
                            qs["id"] = req.id;
                            request.send(req.content);
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_81 = _a.sent();
                            nestedErr = err_81;
                            response = err_81.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserAccountClient.prototype.profileHandlePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__profileHandlePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__profileHandlePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserAccountClient.prototype.__profileHandlePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_82;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/profile/handle')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            if (req.handle !== undefined) {
                                qs["handle"] = req.handle;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_82 = _a.sent();
                            nestedErr = err_82;
                            response = err_82.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserAccountClient.prototype.accountPasswordChangeWithSessionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountPasswordChangeWithSessionPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountPasswordChangeWithSessionPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserAccountClient.prototype.__accountPasswordChangeWithSessionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_83;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/account/password/change/withSession')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_83 = _a.sent();
                            nestedErr = err_83;
                            response = err_83.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserAccountClient.prototype.accountPasswordChangeWithSessionCompletePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountPasswordChangeWithSessionCompletePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountPasswordChangeWithSessionCompletePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserAccountClient.prototype.__accountPasswordChangeWithSessionCompletePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_84;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/account/password/change/withSession/complete')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            if (req.resetCode !== undefined) {
                                qs["resetCode"] = req.resetCode;
                            }
                            if (req.passwordHash !== undefined) {
                                qs["passwordHash"] = req.passwordHash;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_84 = _a.sent();
                            nestedErr = err_84;
                            response = err_84.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserAccountClient.prototype.accountPasswordChangeByEmailAddressPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountPasswordChangeByEmailAddressPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountPasswordChangeByEmailAddressPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserAccountClient.prototype.__accountPasswordChangeByEmailAddressPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_85;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/account/password/change/byEmailAddress')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["emailAddress"] = req.emailAddress;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_85 = _a.sent();
                            nestedErr = err_85;
                            response = err_85.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserAccountClient.prototype.accountPasswordChangeByEmailAddressCompletePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountPasswordChangeByEmailAddressCompletePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountPasswordChangeByEmailAddressCompletePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserAccountClient.prototype.__accountPasswordChangeByEmailAddressCompletePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_86;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/account/password/change/byEmailAddress/complete')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["emailAddress"] = req.emailAddress;
                            if (req.resetCode !== undefined) {
                                qs["resetCode"] = req.resetCode;
                            }
                            if (req.passwordHash !== undefined) {
                                qs["passwordHash"] = req.passwordHash;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_86 = _a.sent();
                            nestedErr = err_86;
                            response = err_86.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserAccountClient.prototype.profileDiscoverGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__profileDiscoverGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__profileDiscoverGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserAccountClient.prototype.__profileDiscoverGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_87;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/profile/discover')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["query"] = req.query;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_87 = _a.sent();
                            nestedErr = err_87;
                            response = err_87.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserAccountClient.prototype.profileGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__profileGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__profileGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserAccountClient.prototype.__profileGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_88;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/profile')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_88 = _a.sent();
                            nestedErr = err_88;
                            response = err_88.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserAccountClient.prototype.profilePOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__profilePOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__profilePOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserAccountClient.prototype.__profilePOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_89;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/profile')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.send(JSON.stringify(req.profileUpdate, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_89 = _a.sent();
                            nestedErr = err_89;
                            response = err_89.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return UserAccountClient;
    }());
    UserSession.UserAccountClient = UserAccountClient;
    var UserSessionClient = /** @class */ (function () {
        function UserSessionClient(apiKey) {
            this.getOriginalApiId = function () { return "user-session"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://user-session-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        UserSessionClient.prototype.sessionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserSessionClient.prototype.__sessionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_90;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_90 = _a.sent();
                            nestedErr = err_90;
                            response = err_90.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserSessionClient.prototype.sessionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserSessionClient.prototype.__sessionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_91;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["authenticationProvider"] = req.authenticationProvider;
                            qs["credentials"] = req.credentials;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_91 = _a.sent();
                            nestedErr = err_91;
                            response = err_91.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserSessionClient.prototype.sessionPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserSessionClient.prototype.__sessionPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_92;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_92 = _a.sent();
                            nestedErr = err_92;
                            response = err_92.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserSessionClient.prototype.sessionDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__sessionDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__sessionDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserSessionClient.prototype.__sessionDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_93;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/session')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_93 = _a.sent();
                            nestedErr = err_93;
                            response = err_93.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserSessionClient.prototype.authenticateSwitchPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__authenticateSwitchPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__authenticateSwitchPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserSessionClient.prototype.__authenticateSwitchPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_94;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/authenticate/switch')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.authenticationSwitch, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_94 = _a.sent();
                            nestedErr = err_94;
                            response = err_94.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserSessionClient.prototype.authenticatePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__authenticatePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__authenticatePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserSessionClient.prototype.__authenticatePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_95;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/authenticate')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.authentication, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_95 = _a.sent();
                            nestedErr = err_95;
                            response = err_95.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return UserSessionClient;
    }());
    UserSession.UserSessionClient = UserSessionClient;
})(UserSession = exports.UserSession || (exports.UserSession = {}));
var Attribute;
(function (Attribute) {
    var AttributeClient = /** @class */ (function () {
        function AttributeClient(apiKey) {
            this.getOriginalApiId = function () { return "attribute"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://attribute-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        AttributeClient.prototype.attributesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__attributesGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__attributesGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AttributeClient.prototype.__attributesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_96;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/attributes')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_96 = _a.sent();
                            nestedErr = err_96;
                            response = err_96.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AttributeClient.prototype.attributeGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__attributeGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__attributeGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AttributeClient.prototype.__attributeGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_97;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/attribute')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            if (req.key !== undefined) {
                                qs["key"] = req.key;
                            }
                            if (req.ownerId !== undefined) {
                                qs["ownerId"] = req.ownerId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_97 = _a.sent();
                            nestedErr = err_97;
                            response = err_97.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AttributeClient.prototype.attributePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__attributePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__attributePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AttributeClient.prototype.__attributePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_98;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/attribute')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            if (req.key !== undefined) {
                                qs["key"] = req.key;
                            }
                            if (req.value !== undefined) {
                                qs["value"] = req.value;
                            }
                            if (req.useProjectAsOwner !== undefined) {
                                qs["useProjectAsOwner"] = req.useProjectAsOwner ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_98 = _a.sent();
                            nestedErr = err_98;
                            response = err_98.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AttributeClient.prototype.attributeDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__attributeDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__attributeDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AttributeClient.prototype.__attributeDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_99;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/attribute')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            if (req.key !== undefined) {
                                qs["key"] = req.key;
                            }
                            if (req.ownerId !== undefined) {
                                qs["ownerId"] = req.ownerId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_99 = _a.sent();
                            nestedErr = err_99;
                            response = err_99.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return AttributeClient;
    }());
    Attribute.AttributeClient = AttributeClient;
})(Attribute = exports.Attribute || (exports.Attribute = {}));
var ClientConnect;
(function (ClientConnect) {
    var FilesClient = /** @class */ (function () {
        function FilesClient(apiKey) {
            this.getOriginalApiId = function () { return "client-connect"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://client-connect-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        FilesClient.prototype.filesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__filesGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__filesGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        FilesClient.prototype.__filesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_100;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/files')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_100 = _a.sent();
                            nestedErr = err_100;
                            response = err_100.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        FilesClient.prototype.serveGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__serveGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__serveGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        FilesClient.prototype.__serveGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_101;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/serve')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.path !== undefined) {
                                qs["path"] = req.path;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_101 = _a.sent();
                            nestedErr = err_101;
                            response = err_101.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return FilesClient;
    }());
    ClientConnect.FilesClient = FilesClient;
    var ServiceClient = /** @class */ (function () {
        function ServiceClient(apiKey) {
            this.getOriginalApiId = function () { return "client-connect"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://client-connect-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        ServiceClient.prototype.serviceEnabledGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__serviceEnabledGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__serviceEnabledGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ServiceClient.prototype.__serviceEnabledGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_102;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/service/enabled')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_102 = _a.sent();
                            nestedErr = err_102;
                            response = err_102.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ServiceClient.prototype.serviceTestPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__serviceTestPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__serviceTestPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ServiceClient.prototype.__serviceTestPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_103;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/service/test')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.testName !== undefined) {
                                qs["testName"] = req.testName;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_103 = _a.sent();
                            nestedErr = err_103;
                            response = err_103.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return ServiceClient;
    }());
    ClientConnect.ServiceClient = ServiceClient;
})(ClientConnect = exports.ClientConnect || (exports.ClientConnect = {}));
var UGCCache;
(function (UGCCache) {
    var UGCCacheClient = /** @class */ (function () {
        function UGCCacheClient(apiKey) {
            this.getOriginalApiId = function () { return "ugc-cache"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://ugc-cache-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        UGCCacheClient.prototype.itemPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__itemPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__itemPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UGCCacheClient.prototype.__itemPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_104;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/item')
                                .set('Content-Type', 'application/octet-stream');
                            qs = {};
                            if (req.lookupKey !== undefined) {
                                qs["lookupKey"] = req.lookupKey;
                            }
                            request.send(req.content);
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_104 = _a.sent();
                            nestedErr = err_104;
                            response = err_104.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UGCCacheClient.prototype.contentGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__contentGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__contentGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UGCCacheClient.prototype.__contentGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_105;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/content')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.lookupKey !== undefined) {
                                qs["lookupKey"] = req.lookupKey;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_105 = _a.sent();
                            nestedErr = err_105;
                            response = err_105.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return UGCCacheClient;
    }());
    UGCCache.UGCCacheClient = UGCCacheClient;
})(UGCCache = exports.UGCCache || (exports.UGCCache = {}));
var NATPunchthrough;
(function (NATPunchthrough) {
    var PunchthroughClient = /** @class */ (function () {
        function PunchthroughClient(apiKey) {
            this.getOriginalApiId = function () { return "nat-punchthrough"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://nat-punchthrough-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        PunchthroughClient.prototype.punchthroughGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__punchthroughGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__punchthroughGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        PunchthroughClient.prototype.__punchthroughGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_106;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/punchthrough')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.session !== undefined) {
                                qs["session"] = req.session;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_106 = _a.sent();
                            nestedErr = err_106;
                            response = err_106.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        PunchthroughClient.prototype.punchthroughPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__punchthroughPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__punchthroughPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        PunchthroughClient.prototype.__punchthroughPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_107;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/punchthrough')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.session !== undefined) {
                                qs["session"] = req.session;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_107 = _a.sent();
                            nestedErr = err_107;
                            response = err_107.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        PunchthroughClient.prototype.endpointsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__endpointsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__endpointsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        PunchthroughClient.prototype.__endpointsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_108;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/endpoints')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.session !== undefined) {
                                qs["session"] = req.session;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_108 = _a.sent();
                            nestedErr = err_108;
                            response = err_108.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return PunchthroughClient;
    }());
    NATPunchthrough.PunchthroughClient = PunchthroughClient;
})(NATPunchthrough = exports.NATPunchthrough || (exports.NATPunchthrough = {}));
var Search;
(function (Search) {
    var ClusterClient = /** @class */ (function () {
        function ClusterClient(apiKey) {
            this.getOriginalApiId = function () { return "search"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://search-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        return ClusterClient;
    }());
    Search.ClusterClient = ClusterClient;
    var SearchClient = /** @class */ (function () {
        function SearchClient(apiKey) {
            this.getOriginalApiId = function () { return "search"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://search-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        SearchClient.prototype.searchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__searchGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__searchGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        SearchClient.prototype.__searchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_109;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/search')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.type !== undefined) {
                                qs["type"] = req.type;
                            }
                            if (req.input !== undefined) {
                                qs["input"] = req.input;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_109 = _a.sent();
                            nestedErr = err_109;
                            response = err_109.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        SearchClient.prototype.indexPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__indexPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__indexPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        SearchClient.prototype.__indexPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_110;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/index')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.type !== undefined) {
                                qs["type"] = req.type;
                            }
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            if (req.title !== undefined) {
                                qs["title"] = req.title;
                            }
                            if (req.text !== undefined) {
                                qs["text"] = req.text;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_110 = _a.sent();
                            nestedErr = err_110;
                            response = err_110.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        SearchClient.prototype.indexDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__indexDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__indexDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        SearchClient.prototype.__indexDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_111;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/index')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.type !== undefined) {
                                qs["type"] = req.type;
                            }
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_111 = _a.sent();
                            nestedErr = err_111;
                            response = err_111.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return SearchClient;
    }());
    Search.SearchClient = SearchClient;
})(Search = exports.Search || (exports.Search = {}));
var NetcodeIO;
(function (NetcodeIO) {
    var NetcodePublicClient = /** @class */ (function () {
        function NetcodePublicClient(apiKey) {
            this.getOriginalApiId = function () { return "netcode"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://netcode-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        NetcodePublicClient.prototype.publicServersGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__publicServersGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__publicServersGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        NetcodePublicClient.prototype.__publicServersGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_112;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/public/servers')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_112 = _a.sent();
                            nestedErr = err_112;
                            response = err_112.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        NetcodePublicClient.prototype.publicServerGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__publicServerGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__publicServerGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        NetcodePublicClient.prototype.__publicServerGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_113;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/public/server')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_113 = _a.sent();
                            nestedErr = err_113;
                            response = err_113.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        NetcodePublicClient.prototype.publicServerAuthPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__publicServerAuthPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__publicServerAuthPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        NetcodePublicClient.prototype.__publicServerAuthPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_114;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/public/server/auth')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_114 = _a.sent();
                            nestedErr = err_114;
                            response = err_114.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return NetcodePublicClient;
    }());
    NetcodeIO.NetcodePublicClient = NetcodePublicClient;
    var NetcodeServerClient = /** @class */ (function () {
        function NetcodeServerClient(apiKey) {
            this.getOriginalApiId = function () { return "netcode"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://netcode-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        NetcodeServerClient.prototype.serversGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__serversGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__serversGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        NetcodeServerClient.prototype.__serversGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_115;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/servers')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_115 = _a.sent();
                            nestedErr = err_115;
                            response = err_115.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        NetcodeServerClient.prototype.serverGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__serverGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__serverGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        NetcodeServerClient.prototype.__serverGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_116;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/server')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_116 = _a.sent();
                            nestedErr = err_116;
                            response = err_116.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        NetcodeServerClient.prototype.serverPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__serverPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__serverPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        NetcodeServerClient.prototype.__serverPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_117;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/server')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["name"] = req.name;
                            qs["serverProtocolIdHexadecimal"] = req.serverProtocolIdHexadecimal;
                            qs["serverIpAddress"] = req.serverIpAddress;
                            qs["serverPort"] = req.serverPort.toString();
                            qs["tokenExpirySeconds"] = req.tokenExpirySeconds.toString();
                            qs["serverTimeoutSeconds"] = req.serverTimeoutSeconds.toString();
                            qs["userdataMode"] = req.userdataMode;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_117 = _a.sent();
                            nestedErr = err_117;
                            response = err_117.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        NetcodeServerClient.prototype.serverPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__serverPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__serverPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        NetcodeServerClient.prototype.__serverPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_118;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/server')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            qs["name"] = req.name;
                            qs["serverProtocolIdHexadecimal"] = req.serverProtocolIdHexadecimal;
                            qs["serverIpAddress"] = req.serverIpAddress;
                            qs["serverPort"] = req.serverPort.toString();
                            qs["tokenExpirySeconds"] = req.tokenExpirySeconds.toString();
                            qs["serverTimeoutSeconds"] = req.serverTimeoutSeconds.toString();
                            qs["userdataMode"] = req.userdataMode;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_118 = _a.sent();
                            nestedErr = err_118;
                            response = err_118.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        NetcodeServerClient.prototype.serverDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__serverDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__serverDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        NetcodeServerClient.prototype.__serverDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_119;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/server')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_119 = _a.sent();
                            nestedErr = err_119;
                            response = err_119.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return NetcodeServerClient;
    }());
    NetcodeIO.NetcodeServerClient = NetcodeServerClient;
})(NetcodeIO = exports.NetcodeIO || (exports.NetcodeIO = {}));
var Presence;
(function (Presence) {
    var PresenceClient = /** @class */ (function () {
        function PresenceClient(apiKey) {
            this.getOriginalApiId = function () { return "presence"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://presence-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        PresenceClient.prototype.presenceConnectGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__presenceConnectGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__presenceConnectGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        PresenceClient.prototype.__presenceConnectGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_120;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/presence/connect')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_120 = _a.sent();
                            nestedErr = err_120;
                            response = err_120.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        PresenceClient.prototype.presenceUserGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__presenceUserGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__presenceUserGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        PresenceClient.prototype.__presenceUserGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_121;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/presence/user')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_121 = _a.sent();
                            nestedErr = err_121;
                            response = err_121.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return PresenceClient;
    }());
    Presence.PresenceClient = PresenceClient;
})(Presence = exports.Presence || (exports.Presence = {}));
var PointOfSale;
(function (PointOfSale) {
    var EventClient = /** @class */ (function () {
        function EventClient(apiKey) {
            this.getOriginalApiId = function () { return "pos"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://pos-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        EventClient.prototype.eventsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__eventsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__eventsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventClient.prototype.__eventsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_122;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/events')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            if (req.showHidden !== undefined) {
                                qs["showHidden"] = req.showHidden ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_122 = _a.sent();
                            nestedErr = err_122;
                            response = err_122.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        EventClient.prototype.eventsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__eventsSearchGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__eventsSearchGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventClient.prototype.__eventsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_123;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/events/search')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.text !== undefined) {
                                qs["text"] = req.text;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_123 = _a.sent();
                            nestedErr = err_123;
                            response = err_123.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        EventClient.prototype.eventGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__eventGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__eventGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventClient.prototype.__eventGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_124;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/event')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_124 = _a.sent();
                            nestedErr = err_124;
                            response = err_124.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        EventClient.prototype.eventPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__eventPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__eventPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventClient.prototype.__eventPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_125;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/event')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            if (req.eventStartUtc !== undefined) {
                                qs["eventStartUtc"] = req.eventStartUtc.unix().toString();
                            }
                            if (req.eventEndUtc !== undefined) {
                                qs["eventEndUtc"] = req.eventEndUtc.unix().toString();
                            }
                            request.send(JSON.stringify(req.productIds, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_125 = _a.sent();
                            nestedErr = err_125;
                            response = err_125.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        EventClient.prototype.eventPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__eventPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__eventPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        EventClient.prototype.__eventPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_126;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/event')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            if (req.eventStartUtc !== undefined) {
                                qs["eventStartUtc"] = req.eventStartUtc.unix().toString();
                            }
                            if (req.eventEndUtc !== undefined) {
                                qs["eventEndUtc"] = req.eventEndUtc.unix().toString();
                            }
                            request.send(JSON.stringify(req.productIds, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_126 = _a.sent();
                            nestedErr = err_126;
                            response = err_126.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return EventClient;
    }());
    PointOfSale.EventClient = EventClient;
    var LicenseKeyClient = /** @class */ (function () {
        function LicenseKeyClient(apiKey) {
            this.getOriginalApiId = function () { return "pos"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://pos-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        LicenseKeyClient.prototype.poolsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__poolsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__poolsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__poolsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_127;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/pools')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            if (req.showHidden !== undefined) {
                                qs["showHidden"] = req.showHidden ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_127 = _a.sent();
                            nestedErr = err_127;
                            response = err_127.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.poolsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__poolsSearchGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__poolsSearchGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__poolsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_128;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/pools/search')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.text !== undefined) {
                                qs["text"] = req.text;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_128 = _a.sent();
                            nestedErr = err_128;
                            response = err_128.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.poolGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__poolGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__poolGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__poolGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_129;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/pool')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_129 = _a.sent();
                            nestedErr = err_129;
                            response = err_129.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.poolPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__poolPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__poolPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__poolPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_130;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/pool')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.description !== undefined) {
                                qs["description"] = req.description;
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_130 = _a.sent();
                            nestedErr = err_130;
                            response = err_130.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.poolPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__poolPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__poolPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__poolPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_131;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/pool')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.description !== undefined) {
                                qs["description"] = req.description;
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_131 = _a.sent();
                            nestedErr = err_131;
                            response = err_131.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.keysPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keysPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keysPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__keysPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_132;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/keys')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.send(JSON.stringify(req.keys, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_132 = _a.sent();
                            nestedErr = err_132;
                            response = err_132.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.keysReservePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keysReservePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keysReservePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__keysReservePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_133;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/keys/reserve')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.poolId !== undefined) {
                                qs["poolId"] = req.poolId;
                            }
                            if (req.eventId !== undefined) {
                                qs["eventId"] = req.eventId;
                            }
                            if (req.userEmail !== undefined) {
                                qs["userEmail"] = req.userEmail;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_133 = _a.sent();
                            nestedErr = err_133;
                            response = err_133.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.keysIssuePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keysIssuePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keysIssuePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__keysIssuePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_134;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/keys/issue')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.poolId !== undefined) {
                                qs["poolId"] = req.poolId;
                            }
                            if (req.eventId !== undefined) {
                                qs["eventId"] = req.eventId;
                            }
                            if (req.key !== undefined) {
                                qs["key"] = req.key;
                            }
                            if (req.userEmail !== undefined) {
                                qs["userEmail"] = req.userEmail;
                            }
                            if (req.notes !== undefined) {
                                qs["notes"] = req.notes;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_134 = _a.sent();
                            nestedErr = err_134;
                            response = err_134.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.keysByReservedEmailGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keysByReservedEmailGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keysByReservedEmailGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__keysByReservedEmailGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_135;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/keys/byReservedEmail')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.poolId !== undefined) {
                                qs["poolId"] = req.poolId;
                            }
                            if (req.email !== undefined) {
                                qs["email"] = req.email;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_135 = _a.sent();
                            nestedErr = err_135;
                            response = err_135.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.keysByIssuedEmailGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keysByIssuedEmailGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keysByIssuedEmailGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__keysByIssuedEmailGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_136;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/keys/byIssuedEmail')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.poolId !== undefined) {
                                qs["poolId"] = req.poolId;
                            }
                            if (req.email !== undefined) {
                                qs["email"] = req.email;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_136 = _a.sent();
                            nestedErr = err_136;
                            response = err_136.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return LicenseKeyClient;
    }());
    PointOfSale.LicenseKeyClient = LicenseKeyClient;
    var ProductClient = /** @class */ (function () {
        function ProductClient(apiKey) {
            this.getOriginalApiId = function () { return "pos"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://pos-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        ProductClient.prototype.productGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__productGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__productGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProductClient.prototype.__productGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_137;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/product')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.productId !== undefined) {
                                qs["productId"] = req.productId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_137 = _a.sent();
                            nestedErr = err_137;
                            response = err_137.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProductClient.prototype.productPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__productPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__productPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProductClient.prototype.__productPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_138;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/product')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.productId !== undefined) {
                                qs["productId"] = req.productId;
                            }
                            if (req.enabled !== undefined) {
                                qs["enabled"] = req.enabled ? "true" : "false";
                            }
                            if (req.currencyCode !== undefined) {
                                qs["currencyCode"] = req.currencyCode;
                            }
                            if (req.currencyUnits !== undefined) {
                                qs["currencyUnits"] = req.currencyUnits.toString();
                            }
                            if (req.licenseKeyPoolId !== undefined) {
                                qs["licenseKeyPoolId"] = req.licenseKeyPoolId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_138 = _a.sent();
                            nestedErr = err_138;
                            response = err_138.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return ProductClient;
    }());
    PointOfSale.ProductClient = ProductClient;
})(PointOfSale = exports.PointOfSale || (exports.PointOfSale = {}));
var Billing;
(function (Billing) {
    var AccessClient = /** @class */ (function () {
        function AccessClient(apiKey) {
            this.getOriginalApiId = function () { return "billing"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://billing-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        AccessClient.prototype.accountUserAccessPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountUserAccessPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountUserAccessPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AccessClient.prototype.__accountUserAccessPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_139;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/account/user/access')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["accountId"] = req.accountId;
                            if (req.adminUsername !== undefined) {
                                qs["adminUsername"] = req.adminUsername;
                            }
                            if (req.userAccountId !== undefined) {
                                qs["userAccountId"] = req.userAccountId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_139 = _a.sent();
                            nestedErr = err_139;
                            response = err_139.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AccessClient.prototype.accountUserAccessDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountUserAccessDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountUserAccessDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AccessClient.prototype.__accountUserAccessDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_140;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/account/user/access')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["accountId"] = req.accountId;
                            if (req.adminUsername !== undefined) {
                                qs["adminUsername"] = req.adminUsername;
                            }
                            if (req.userAccountId !== undefined) {
                                qs["userAccountId"] = req.userAccountId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_140 = _a.sent();
                            nestedErr = err_140;
                            response = err_140.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AccessClient.prototype.accountUsersAccessGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountUsersAccessGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountUsersAccessGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AccessClient.prototype.__accountUsersAccessGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_141;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/account/users/access')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["accountId"] = req.accountId;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_141 = _a.sent();
                            nestedErr = err_141;
                            response = err_141.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return AccessClient;
    }());
    Billing.AccessClient = AccessClient;
    var AccountClient = /** @class */ (function () {
        function AccountClient(apiKey) {
            this.getOriginalApiId = function () { return "billing"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://billing-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        AccountClient.prototype.accountGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AccountClient.prototype.__accountGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_142;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/account')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_142 = _a.sent();
                            nestedErr = err_142;
                            response = err_142.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AccountClient.prototype.accountPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AccountClient.prototype.__accountPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_143;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/account')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.account, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_143 = _a.sent();
                            nestedErr = err_143;
                            response = err_143.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AccountClient.prototype.accountPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AccountClient.prototype.__accountPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_144;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/account')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            qs["archived"] = req.archived ? "true" : "false";
                            request.send(JSON.stringify(req.account, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_144 = _a.sent();
                            nestedErr = err_144;
                            response = err_144.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AccountClient.prototype.accountPaymentSingularPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountPaymentSingularPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountPaymentSingularPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AccountClient.prototype.__accountPaymentSingularPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_145;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/account/payment/singular')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            qs["token"] = req.token;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_145 = _a.sent();
                            nestedErr = err_145;
                            response = err_145.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AccountClient.prototype.accountsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AccountClient.prototype.__accountsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_146;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/accounts')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_146 = _a.sent();
                            nestedErr = err_146;
                            response = err_146.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AccountClient.prototype.accountChargePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountChargePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountChargePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AccountClient.prototype.__accountChargePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_147;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/account/charge')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_147 = _a.sent();
                            nestedErr = err_147;
                            response = err_147.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AccountClient.prototype.accountSyncPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountSyncPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountSyncPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AccountClient.prototype.__accountSyncPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_148;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/account/sync')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["id"] = req.id;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_148 = _a.sent();
                            nestedErr = err_148;
                            response = err_148.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return AccountClient;
    }());
    Billing.AccountClient = AccountClient;
    var AggregationClient = /** @class */ (function () {
        function AggregationClient(apiKey) {
            this.getOriginalApiId = function () { return "billing"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://billing-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        AggregationClient.prototype.aggregationInfoGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__aggregationInfoGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__aggregationInfoGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AggregationClient.prototype.__aggregationInfoGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_149;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/aggregation/info')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_149 = _a.sent();
                            nestedErr = err_149;
                            response = err_149.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        AggregationClient.prototype.aggregationQueuePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__aggregationQueuePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__aggregationQueuePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        AggregationClient.prototype.__aggregationQueuePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_150;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/aggregation/queue')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_150 = _a.sent();
                            nestedErr = err_150;
                            response = err_150.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return AggregationClient;
    }());
    Billing.AggregationClient = AggregationClient;
    var DiscountClient = /** @class */ (function () {
        function DiscountClient(apiKey) {
            this.getOriginalApiId = function () { return "billing"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://billing-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        DiscountClient.prototype.accountDiscountGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountDiscountGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountDiscountGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        DiscountClient.prototype.__accountDiscountGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_151;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/account/discount')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["accountId"] = req.accountId;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_151 = _a.sent();
                            nestedErr = err_151;
                            response = err_151.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return DiscountClient;
    }());
    Billing.DiscountClient = DiscountClient;
    var InvoiceClient = /** @class */ (function () {
        function InvoiceClient(apiKey) {
            this.getOriginalApiId = function () { return "billing"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://billing-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        InvoiceClient.prototype.accountInvoicesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountInvoicesGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountInvoicesGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__accountInvoicesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_152;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/account/invoices')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["accountId"] = req.accountId;
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_152 = _a.sent();
                            nestedErr = err_152;
                            response = err_152.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.accountInvoiceGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountInvoiceGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountInvoiceGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__accountInvoiceGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_153;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/account/invoice')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["accountId"] = req.accountId;
                            qs["invoiceId"] = req.invoiceId;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_153 = _a.sent();
                            nestedErr = err_153;
                            response = err_153.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return InvoiceClient;
    }());
    Billing.InvoiceClient = InvoiceClient;
    var PlanClient = /** @class */ (function () {
        function PlanClient(apiKey) {
            this.getOriginalApiId = function () { return "billing"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://billing-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        return PlanClient;
    }());
    Billing.PlanClient = PlanClient;
    var ProjectClient = /** @class */ (function () {
        function ProjectClient(apiKey) {
            this.getOriginalApiId = function () { return "billing"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://billing-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        ProjectClient.prototype.accountProjectPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountProjectPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountProjectPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectClient.prototype.__accountProjectPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_154;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/account/project')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["accountId"] = req.accountId;
                            qs["projectId"] = req.projectId;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_154 = _a.sent();
                            nestedErr = err_154;
                            response = err_154.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProjectClient.prototype.accountProjectsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__accountProjectsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__accountProjectsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProjectClient.prototype.__accountProjectsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_155;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/account/projects')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["accountId"] = req.accountId;
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_155 = _a.sent();
                            nestedErr = err_155;
                            response = err_155.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return ProjectClient;
    }());
    Billing.ProjectClient = ProjectClient;
    var StripeClient = /** @class */ (function () {
        function StripeClient(apiKey) {
            this.getOriginalApiId = function () { return "billing"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://billing-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        StripeClient.prototype.stripeWebhookPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__stripeWebhookPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__stripeWebhookPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        StripeClient.prototype.__stripeWebhookPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_156;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/stripe/webhook')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_156 = _a.sent();
                            nestedErr = err_156;
                            response = err_156.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        StripeClient.prototype.stripePublicKeyGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__stripePublicKeyGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__stripePublicKeyGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        StripeClient.prototype.__stripePublicKeyGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_157;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/stripe/publicKey')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_157 = _a.sent();
                            nestedErr = err_157;
                            response = err_157.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return StripeClient;
    }());
    Billing.StripeClient = StripeClient;
})(Billing = exports.Billing || (exports.Billing = {}));
var IntegrationConfiguration;
(function (IntegrationConfiguration) {
    var IntegrationCredentialClient = /** @class */ (function () {
        function IntegrationCredentialClient(apiKey) {
            this.getOriginalApiId = function () { return "integration"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://integration-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        IntegrationCredentialClient.prototype.credentialsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__credentialsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__credentialsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        IntegrationCredentialClient.prototype.__credentialsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_158;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/credentials')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            if (req.showHidden !== undefined) {
                                qs["showHidden"] = req.showHidden ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_158 = _a.sent();
                            nestedErr = err_158;
                            response = err_158.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        IntegrationCredentialClient.prototype.credentialTypesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__credentialTypesGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__credentialTypesGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        IntegrationCredentialClient.prototype.__credentialTypesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_159;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/credentialTypes')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_159 = _a.sent();
                            nestedErr = err_159;
                            response = err_159.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        IntegrationCredentialClient.prototype.credentialsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__credentialsSearchGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__credentialsSearchGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        IntegrationCredentialClient.prototype.__credentialsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_160;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/credentials/search')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.text !== undefined) {
                                qs["text"] = req.text;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_160 = _a.sent();
                            nestedErr = err_160;
                            response = err_160.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        IntegrationCredentialClient.prototype.credentialGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__credentialGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__credentialGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        IntegrationCredentialClient.prototype.__credentialGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_161;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/credential')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_161 = _a.sent();
                            nestedErr = err_161;
                            response = err_161.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        IntegrationCredentialClient.prototype.credentialPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__credentialPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__credentialPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        IntegrationCredentialClient.prototype.__credentialPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_162;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/credential')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.integrationCredential, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_162 = _a.sent();
                            nestedErr = err_162;
                            response = err_162.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        IntegrationCredentialClient.prototype.credentialPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__credentialPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__credentialPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        IntegrationCredentialClient.prototype.__credentialPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_163;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/credential')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.integrationCredential, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_163 = _a.sent();
                            nestedErr = err_163;
                            response = err_163.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return IntegrationCredentialClient;
    }());
    IntegrationConfiguration.IntegrationCredentialClient = IntegrationCredentialClient;
    var SteamClient = /** @class */ (function () {
        function SteamClient(apiKey) {
            this.getOriginalApiId = function () { return "integration"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://integration-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        SteamClient.prototype.steamPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__steamPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__steamPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        SteamClient.prototype.__steamPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_164;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/steam')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["steamAppId"] = req.steamAppId;
                            qs["publisherKey"] = req.publisherKey;
                            qs["publisherUsername"] = req.publisherUsername;
                            qs["publisherPassword"] = req.publisherPassword;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_164 = _a.sent();
                            nestedErr = err_164;
                            response = err_164.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        SteamClient.prototype.steamStatusGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__steamStatusGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__steamStatusGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        SteamClient.prototype.__steamStatusGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_165;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/steam/status')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_165 = _a.sent();
                            nestedErr = err_165;
                            response = err_165.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        SteamClient.prototype.steamGuardGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__steamGuardGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__steamGuardGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        SteamClient.prototype.__steamGuardGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_166;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/steam/guard')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_166 = _a.sent();
                            nestedErr = err_166;
                            response = err_166.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        SteamClient.prototype.steamGuardPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__steamGuardPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__steamGuardPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        SteamClient.prototype.__steamGuardPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_167;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/steam/guard')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["steamGuardCode"] = req.steamGuardCode;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_167 = _a.sent();
                            nestedErr = err_167;
                            response = err_167.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        SteamClient.prototype.steamReimportPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__steamReimportPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__steamReimportPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        SteamClient.prototype.__steamReimportPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_168;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/steam/reimport')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_168 = _a.sent();
                            nestedErr = err_168;
                            response = err_168.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        SteamClient.prototype.steamErrormsgGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__steamErrormsgGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__steamErrormsgGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        SteamClient.prototype.__steamErrormsgGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_169;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/steam/errormsg')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_169 = _a.sent();
                            nestedErr = err_169;
                            response = err_169.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return SteamClient;
    }());
    IntegrationConfiguration.SteamClient = SteamClient;
    var SteamStateClient = /** @class */ (function () {
        function SteamStateClient(apiKey) {
            this.getOriginalApiId = function () { return "integration"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://integration-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        return SteamStateClient;
    }());
    IntegrationConfiguration.SteamStateClient = SteamStateClient;
    var StripeClient = /** @class */ (function () {
        function StripeClient(apiKey) {
            this.getOriginalApiId = function () { return "integration"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://integration-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        StripeClient.prototype.stripePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__stripePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__stripePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        StripeClient.prototype.__stripePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_170;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/stripe')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.publicKey !== undefined) {
                                qs["publicKey"] = req.publicKey;
                            }
                            if (req.secretKey !== undefined) {
                                qs["secretKey"] = req.secretKey;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_170 = _a.sent();
                            nestedErr = err_170;
                            response = err_170.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        StripeClient.prototype.stripeDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__stripeDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__stripeDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        StripeClient.prototype.__stripeDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_171;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/stripe')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_171 = _a.sent();
                            nestedErr = err_171;
                            response = err_171.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        StripeClient.prototype.stripeTogglePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__stripeTogglePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__stripeTogglePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        StripeClient.prototype.__stripeTogglePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_172;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/stripe/toggle')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.enabled !== undefined) {
                                qs["enabled"] = req.enabled ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_172 = _a.sent();
                            nestedErr = err_172;
                            response = err_172.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        StripeClient.prototype.stripeStatusGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__stripeStatusGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__stripeStatusGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        StripeClient.prototype.__stripeStatusGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_173;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/stripe/status')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_173 = _a.sent();
                            nestedErr = err_173;
                            response = err_173.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return StripeClient;
    }());
    IntegrationConfiguration.StripeClient = StripeClient;
})(IntegrationConfiguration = exports.IntegrationConfiguration || (exports.IntegrationConfiguration = {}));
var Licensing;
(function (Licensing) {
    var LicenseKeyClient = /** @class */ (function () {
        function LicenseKeyClient(apiKey) {
            this.getOriginalApiId = function () { return "licensing"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://licensing-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        LicenseKeyClient.prototype.poolsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__poolsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__poolsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__poolsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_174;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/pools')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            if (req.showHidden !== undefined) {
                                qs["showHidden"] = req.showHidden ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_174 = _a.sent();
                            nestedErr = err_174;
                            response = err_174.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.poolsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__poolsSearchGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__poolsSearchGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__poolsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_175;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/pools/search')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.text !== undefined) {
                                qs["text"] = req.text;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_175 = _a.sent();
                            nestedErr = err_175;
                            response = err_175.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.poolGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__poolGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__poolGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__poolGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_176;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/pool')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_176 = _a.sent();
                            nestedErr = err_176;
                            response = err_176.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.poolPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__poolPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__poolPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__poolPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_177;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/pool')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.description !== undefined) {
                                qs["description"] = req.description;
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_177 = _a.sent();
                            nestedErr = err_177;
                            response = err_177.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.poolPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__poolPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__poolPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__poolPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_178;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/pool')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.description !== undefined) {
                                qs["description"] = req.description;
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_178 = _a.sent();
                            nestedErr = err_178;
                            response = err_178.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.keysPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keysPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keysPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__keysPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_179;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/keys')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.send(JSON.stringify(req.keys, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_179 = _a.sent();
                            nestedErr = err_179;
                            response = err_179.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.keysReservePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keysReservePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keysReservePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__keysReservePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_180;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/keys/reserve')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.poolId !== undefined) {
                                qs["poolId"] = req.poolId;
                            }
                            if (req.userEmail !== undefined) {
                                qs["userEmail"] = req.userEmail;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_180 = _a.sent();
                            nestedErr = err_180;
                            response = err_180.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.keysIssuePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keysIssuePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keysIssuePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__keysIssuePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_181;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/keys/issue')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.poolId !== undefined) {
                                qs["poolId"] = req.poolId;
                            }
                            if (req.key !== undefined) {
                                qs["key"] = req.key;
                            }
                            if (req.userEmail !== undefined) {
                                qs["userEmail"] = req.userEmail;
                            }
                            if (req.notes !== undefined) {
                                qs["notes"] = req.notes;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_181 = _a.sent();
                            nestedErr = err_181;
                            response = err_181.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.keysByReservedEmailGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keysByReservedEmailGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keysByReservedEmailGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__keysByReservedEmailGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_182;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/keys/byReservedEmail')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.poolId !== undefined) {
                                qs["poolId"] = req.poolId;
                            }
                            if (req.email !== undefined) {
                                qs["email"] = req.email;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_182 = _a.sent();
                            nestedErr = err_182;
                            response = err_182.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.keysByIssuedEmailGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__keysByIssuedEmailGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__keysByIssuedEmailGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        LicenseKeyClient.prototype.__keysByIssuedEmailGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_183;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/keys/byIssuedEmail')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.poolId !== undefined) {
                                qs["poolId"] = req.poolId;
                            }
                            if (req.email !== undefined) {
                                qs["email"] = req.email;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_183 = _a.sent();
                            nestedErr = err_183;
                            response = err_183.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return LicenseKeyClient;
    }());
    Licensing.LicenseKeyClient = LicenseKeyClient;
})(Licensing = exports.Licensing || (exports.Licensing = {}));
var RevenueShare;
(function (RevenueShare) {
    var InvoiceClient = /** @class */ (function () {
        function InvoiceClient(apiKey) {
            this.getOriginalApiId = function () { return "revenue-share"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://revenue-share-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        InvoiceClient.prototype.invoicesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicesGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicesGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_184;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/invoices')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            if (req.showHidden !== undefined) {
                                qs["showHidden"] = req.showHidden ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_184 = _a.sent();
                            nestedErr = err_184;
                            response = err_184.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicesSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicesSearchGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicesSearchGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicesSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_185;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/invoices/search')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.text !== undefined) {
                                qs["text"] = req.text;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_185 = _a.sent();
                            nestedErr = err_185;
                            response = err_185.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoiceGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoiceGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoiceGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoiceGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_186;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/invoice')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.invoiceId !== undefined) {
                                qs["invoiceId"] = req.invoiceId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_186 = _a.sent();
                            nestedErr = err_186;
                            response = err_186.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_187;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/invoice')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.invoiceNumber !== undefined) {
                                qs["invoiceNumber"] = req.invoiceNumber;
                            }
                            if (req.notes !== undefined) {
                                qs["notes"] = req.notes;
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_187 = _a.sent();
                            nestedErr = err_187;
                            response = err_187.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicePOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicePOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicePOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicePOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_188;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/invoice')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.invoiceId !== undefined) {
                                qs["invoiceId"] = req.invoiceId;
                            }
                            if (req.invoiceNumber !== undefined) {
                                qs["invoiceNumber"] = req.invoiceNumber;
                            }
                            if (req.notes !== undefined) {
                                qs["notes"] = req.notes;
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_188 = _a.sent();
                            nestedErr = err_188;
                            response = err_188.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicePostPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicePostPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicePostPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicePostPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_189;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/invoice/post')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.invoiceId !== undefined) {
                                qs["invoiceId"] = req.invoiceId;
                            }
                            if (req.postNotes !== undefined) {
                                qs["postNotes"] = req.postNotes;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_189 = _a.sent();
                            nestedErr = err_189;
                            response = err_189.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoiceUnpostPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoiceUnpostPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoiceUnpostPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoiceUnpostPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_190;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/invoice/unpost')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.invoiceId !== undefined) {
                                qs["invoiceId"] = req.invoiceId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_190 = _a.sent();
                            nestedErr = err_190;
                            response = err_190.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoiceItemPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoiceItemPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoiceItemPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoiceItemPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_191;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/invoice/item')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.invoiceId !== undefined) {
                                qs["invoiceId"] = req.invoiceId;
                            }
                            if (req.productId !== undefined) {
                                qs["productId"] = req.productId;
                            }
                            if (req.revenueRulesetIdOverride !== undefined) {
                                qs["revenueRulesetIdOverride"] = req.revenueRulesetIdOverride;
                            }
                            if (req.amount !== undefined) {
                                qs["amount"] = req.amount.toString();
                            }
                            if (req.amountFractionalDivisor !== undefined) {
                                qs["amountFractionalDivisor"] = req.amountFractionalDivisor.toString();
                            }
                            if (req.grossAmount !== undefined) {
                                qs["grossAmount"] = req.grossAmount.toString();
                            }
                            if (req.grossAmountFractionalDivisor !== undefined) {
                                qs["grossAmountFractionalDivisor"] = req.grossAmountFractionalDivisor.toString();
                            }
                            if (req.currency !== undefined) {
                                qs["currency"] = req.currency;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_191 = _a.sent();
                            nestedErr = err_191;
                            response = err_191.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoiceItemPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoiceItemPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoiceItemPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoiceItemPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_192;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/invoice/item')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.invoiceId !== undefined) {
                                qs["invoiceId"] = req.invoiceId;
                            }
                            if (req.invoiceLineItemId !== undefined) {
                                qs["invoiceLineItemId"] = req.invoiceLineItemId;
                            }
                            if (req.productId !== undefined) {
                                qs["productId"] = req.productId;
                            }
                            if (req.revenueRulesetIdOverride !== undefined) {
                                qs["revenueRulesetIdOverride"] = req.revenueRulesetIdOverride;
                            }
                            if (req.amount !== undefined) {
                                qs["amount"] = req.amount.toString();
                            }
                            if (req.amountFractionalDivisor !== undefined) {
                                qs["amountFractionalDivisor"] = req.amountFractionalDivisor.toString();
                            }
                            if (req.grossAmount !== undefined) {
                                qs["grossAmount"] = req.grossAmount.toString();
                            }
                            if (req.grossAmountFractionalDivisor !== undefined) {
                                qs["grossAmountFractionalDivisor"] = req.grossAmountFractionalDivisor.toString();
                            }
                            if (req.currency !== undefined) {
                                qs["currency"] = req.currency;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_192 = _a.sent();
                            nestedErr = err_192;
                            response = err_192.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoiceItemDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoiceItemDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoiceItemDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoiceItemDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_193;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/invoice/item')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.invoiceId !== undefined) {
                                qs["invoiceId"] = req.invoiceId;
                            }
                            if (req.invoiceLineItemId !== undefined) {
                                qs["invoiceLineItemId"] = req.invoiceLineItemId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_193 = _a.sent();
                            nestedErr = err_193;
                            response = err_193.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicePaymentsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicePaymentsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicePaymentsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicePaymentsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_194;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/invoice/payments')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.invoiceId !== undefined) {
                                qs["invoiceId"] = req.invoiceId;
                            }
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_194 = _a.sent();
                            nestedErr = err_194;
                            response = err_194.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicePaymentGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicePaymentGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicePaymentGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicePaymentGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_195;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/invoice/payment')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.paymentId !== undefined) {
                                qs["paymentId"] = req.paymentId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_195 = _a.sent();
                            nestedErr = err_195;
                            response = err_195.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicePaymentPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicePaymentPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicePaymentPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicePaymentPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_196;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/invoice/payment')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.invoiceId !== undefined) {
                                qs["invoiceId"] = req.invoiceId;
                            }
                            if (req.paymentNumber !== undefined) {
                                qs["paymentNumber"] = req.paymentNumber;
                            }
                            if (req.notes !== undefined) {
                                qs["notes"] = req.notes;
                            }
                            if (req.decimalPlaces !== undefined) {
                                qs["decimalPlaces"] = req.decimalPlaces.toString();
                            }
                            if (req.fractionalRecipientId !== undefined) {
                                qs["fractionalRecipientId"] = req.fractionalRecipientId;
                            }
                            request.send(JSON.stringify(req.lineItems, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_196 = _a.sent();
                            nestedErr = err_196;
                            response = err_196.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicePaymentPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicePaymentPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicePaymentPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicePaymentPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_197;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/invoice/payment')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.paymentId !== undefined) {
                                qs["paymentId"] = req.paymentId;
                            }
                            if (req.paymentNumber !== undefined) {
                                qs["paymentNumber"] = req.paymentNumber;
                            }
                            if (req.notes !== undefined) {
                                qs["notes"] = req.notes;
                            }
                            if (req.decimalPlaces !== undefined) {
                                qs["decimalPlaces"] = req.decimalPlaces.toString();
                            }
                            if (req.fractionalRecipientId !== undefined) {
                                qs["fractionalRecipientId"] = req.fractionalRecipientId;
                            }
                            request.send(JSON.stringify(req.lineItems, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_197 = _a.sent();
                            nestedErr = err_197;
                            response = err_197.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicePaymentTransactionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicePaymentTransactionsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicePaymentTransactionsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicePaymentTransactionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_198;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/invoice/payment/transactions')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.paymentId !== undefined) {
                                qs["paymentId"] = req.paymentId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_198 = _a.sent();
                            nestedErr = err_198;
                            response = err_198.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicePaymentPostPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicePaymentPostPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicePaymentPostPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicePaymentPostPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_199;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/invoice/payment/post')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.paymentId !== undefined) {
                                qs["paymentId"] = req.paymentId;
                            }
                            if (req.postNotes !== undefined) {
                                qs["postNotes"] = req.postNotes;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_199 = _a.sent();
                            nestedErr = err_199;
                            response = err_199.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicePaymentUnpostPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicePaymentUnpostPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicePaymentUnpostPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicePaymentUnpostPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_200;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/invoice/payment/unpost')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.paymentId !== undefined) {
                                qs["paymentId"] = req.paymentId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_200 = _a.sent();
                            nestedErr = err_200;
                            response = err_200.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicePaymentProcessPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicePaymentProcessPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicePaymentProcessPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicePaymentProcessPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_201;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/invoice/payment/process')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.paymentId !== undefined) {
                                qs["paymentId"] = req.paymentId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_201 = _a.sent();
                            nestedErr = err_201;
                            response = err_201.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicePaymentProgressGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicePaymentProgressGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicePaymentProgressGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicePaymentProgressGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_202;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/invoice/payment/progress')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.paymentId !== undefined) {
                                qs["paymentId"] = req.paymentId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_202 = _a.sent();
                            nestedErr = err_202;
                            response = err_202.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        InvoiceClient.prototype.invoicePaymentRequeuePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__invoicePaymentRequeuePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__invoicePaymentRequeuePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        InvoiceClient.prototype.__invoicePaymentRequeuePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_203;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/invoice/payment/requeue')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.paymentId !== undefined) {
                                qs["paymentId"] = req.paymentId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_203 = _a.sent();
                            nestedErr = err_203;
                            response = err_203.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return InvoiceClient;
    }());
    RevenueShare.InvoiceClient = InvoiceClient;
    var ProductClient = /** @class */ (function () {
        function ProductClient(apiKey) {
            this.getOriginalApiId = function () { return "revenue-share"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://revenue-share-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        ProductClient.prototype.productsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__productsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__productsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProductClient.prototype.__productsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_204;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/products')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            if (req.showHidden !== undefined) {
                                qs["showHidden"] = req.showHidden ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_204 = _a.sent();
                            nestedErr = err_204;
                            response = err_204.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProductClient.prototype.productsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__productsSearchGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__productsSearchGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProductClient.prototype.__productsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_205;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/products/search')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.text !== undefined) {
                                qs["text"] = req.text;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_205 = _a.sent();
                            nestedErr = err_205;
                            response = err_205.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProductClient.prototype.productGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__productGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__productGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProductClient.prototype.__productGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_206;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/product')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_206 = _a.sent();
                            nestedErr = err_206;
                            response = err_206.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProductClient.prototype.productPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__productPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__productPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProductClient.prototype.__productPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_207;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/product')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.description !== undefined) {
                                qs["description"] = req.description;
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            if (req.defaultRevenueShareRulesetId !== undefined) {
                                qs["defaultRevenueShareRulesetId"] = req.defaultRevenueShareRulesetId;
                            }
                            if (req.dataCaptureProjectId !== undefined) {
                                qs["dataCaptureProjectId"] = req.dataCaptureProjectId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_207 = _a.sent();
                            nestedErr = err_207;
                            response = err_207.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ProductClient.prototype.productPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__productPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__productPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ProductClient.prototype.__productPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_208;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/product')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.description !== undefined) {
                                qs["description"] = req.description;
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            if (req.defaultRevenueShareRulesetId !== undefined) {
                                qs["defaultRevenueShareRulesetId"] = req.defaultRevenueShareRulesetId;
                            }
                            if (req.dataCaptureProjectId !== undefined) {
                                qs["dataCaptureProjectId"] = req.dataCaptureProjectId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_208 = _a.sent();
                            nestedErr = err_208;
                            response = err_208.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return ProductClient;
    }());
    RevenueShare.ProductClient = ProductClient;
    var RecipientClient = /** @class */ (function () {
        function RecipientClient(apiKey) {
            this.getOriginalApiId = function () { return "revenue-share"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://revenue-share-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        RecipientClient.prototype.recipientsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__recipientsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__recipientsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RecipientClient.prototype.__recipientsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_209;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/recipients')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            if (req.showHidden !== undefined) {
                                qs["showHidden"] = req.showHidden ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_209 = _a.sent();
                            nestedErr = err_209;
                            response = err_209.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RecipientClient.prototype.recipientsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__recipientsSearchGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__recipientsSearchGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RecipientClient.prototype.__recipientsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_210;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/recipients/search')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.text !== undefined) {
                                qs["text"] = req.text;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_210 = _a.sent();
                            nestedErr = err_210;
                            response = err_210.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RecipientClient.prototype.recipientGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__recipientGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__recipientGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RecipientClient.prototype.__recipientGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_211;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/recipient')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_211 = _a.sent();
                            nestedErr = err_211;
                            response = err_211.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RecipientClient.prototype.recipientPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__recipientPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__recipientPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RecipientClient.prototype.__recipientPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_212;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/recipient')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.description !== undefined) {
                                qs["description"] = req.description;
                            }
                            if (req.postDistributionTaxPercentage !== undefined) {
                                qs["postDistributionTaxPercentage"] = req.postDistributionTaxPercentage.toString();
                            }
                            if (req.startingBalance !== undefined) {
                                qs["startingBalance"] = req.startingBalance.toString();
                            }
                            if (req.trackBalanceAndPayments !== undefined) {
                                qs["trackBalanceAndPayments"] = req.trackBalanceAndPayments ? "true" : "false";
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_212 = _a.sent();
                            nestedErr = err_212;
                            response = err_212.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RecipientClient.prototype.recipientPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__recipientPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__recipientPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RecipientClient.prototype.__recipientPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_213;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/recipient')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.description !== undefined) {
                                qs["description"] = req.description;
                            }
                            if (req.postDistributionTaxPercentage !== undefined) {
                                qs["postDistributionTaxPercentage"] = req.postDistributionTaxPercentage.toString();
                            }
                            if (req.startingBalance !== undefined) {
                                qs["startingBalance"] = req.startingBalance.toString();
                            }
                            if (req.trackBalanceAndPayments !== undefined) {
                                qs["trackBalanceAndPayments"] = req.trackBalanceAndPayments ? "true" : "false";
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_213 = _a.sent();
                            nestedErr = err_213;
                            response = err_213.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RecipientClient.prototype.recipientTransactionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__recipientTransactionsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__recipientTransactionsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RecipientClient.prototype.__recipientTransactionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_214;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/recipient/transactions')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.recipientId !== undefined) {
                                qs["recipientId"] = req.recipientId;
                            }
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            if (req.showHidden !== undefined) {
                                qs["showHidden"] = req.showHidden ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_214 = _a.sent();
                            nestedErr = err_214;
                            response = err_214.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RecipientClient.prototype.recipientTransactionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__recipientTransactionGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__recipientTransactionGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RecipientClient.prototype.__recipientTransactionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_215;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/recipient/transaction')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.transactionId !== undefined) {
                                qs["transactionId"] = req.transactionId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_215 = _a.sent();
                            nestedErr = err_215;
                            response = err_215.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RecipientClient.prototype.recipientTransactionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__recipientTransactionPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__recipientTransactionPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RecipientClient.prototype.__recipientTransactionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_216;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/recipient/transaction')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.recipientId !== undefined) {
                                qs["recipientId"] = req.recipientId;
                            }
                            if (req.title !== undefined) {
                                qs["title"] = req.title;
                            }
                            if (req.notes !== undefined) {
                                qs["notes"] = req.notes;
                            }
                            if (req.amount !== undefined) {
                                qs["amount"] = req.amount.toString();
                            }
                            if (req.amountFractionalDivisor !== undefined) {
                                qs["amountFractionalDivisor"] = req.amountFractionalDivisor.toString();
                            }
                            if (req.currency !== undefined) {
                                qs["currency"] = req.currency;
                            }
                            if (req.generateTaxTransaction !== undefined) {
                                qs["generateTaxTransaction"] = req.generateTaxTransaction ? "true" : "false";
                            }
                            if (req.taxAmount !== undefined) {
                                qs["taxAmount"] = req.taxAmount.toString();
                            }
                            if (req.taxAmountFractionalDivisor !== undefined) {
                                qs["taxAmountFractionalDivisor"] = req.taxAmountFractionalDivisor.toString();
                            }
                            if (req.taxRecipientId !== undefined) {
                                qs["taxRecipientId"] = req.taxRecipientId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_216 = _a.sent();
                            nestedErr = err_216;
                            response = err_216.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RecipientClient.prototype.recipientTransactionDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__recipientTransactionDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__recipientTransactionDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RecipientClient.prototype.__recipientTransactionDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_217;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/recipient/transaction')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.transactionId !== undefined) {
                                qs["transactionId"] = req.transactionId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_217 = _a.sent();
                            nestedErr = err_217;
                            response = err_217.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return RecipientClient;
    }());
    RevenueShare.RecipientClient = RecipientClient;
    var RevenueShareRulesetClient = /** @class */ (function () {
        function RevenueShareRulesetClient(apiKey) {
            this.getOriginalApiId = function () { return "revenue-share"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://revenue-share-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        RevenueShareRulesetClient.prototype.rulesetsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__rulesetsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__rulesetsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RevenueShareRulesetClient.prototype.__rulesetsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_218;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/rulesets')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            if (req.showHidden !== undefined) {
                                qs["showHidden"] = req.showHidden ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_218 = _a.sent();
                            nestedErr = err_218;
                            response = err_218.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RevenueShareRulesetClient.prototype.rulesetsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__rulesetsSearchGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__rulesetsSearchGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RevenueShareRulesetClient.prototype.__rulesetsSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_219;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/rulesets/search')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.text !== undefined) {
                                qs["text"] = req.text;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_219 = _a.sent();
                            nestedErr = err_219;
                            response = err_219.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RevenueShareRulesetClient.prototype.rulesetGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__rulesetGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__rulesetGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RevenueShareRulesetClient.prototype.__rulesetGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_220;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/ruleset')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_220 = _a.sent();
                            nestedErr = err_220;
                            response = err_220.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RevenueShareRulesetClient.prototype.rulesetPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__rulesetPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__rulesetPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RevenueShareRulesetClient.prototype.__rulesetPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_221;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/ruleset')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.description !== undefined) {
                                qs["description"] = req.description;
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            request.send(JSON.stringify(req.ruleset, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_221 = _a.sent();
                            nestedErr = err_221;
                            response = err_221.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RevenueShareRulesetClient.prototype.rulesetPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__rulesetPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__rulesetPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RevenueShareRulesetClient.prototype.__rulesetPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_222;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/ruleset')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            if (req.name !== undefined) {
                                qs["name"] = req.name;
                            }
                            if (req.description !== undefined) {
                                qs["description"] = req.description;
                            }
                            if (req.visible !== undefined) {
                                qs["visible"] = req.visible ? "true" : "false";
                            }
                            request.send(JSON.stringify(req.ruleset, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_222 = _a.sent();
                            nestedErr = err_222;
                            response = err_222.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        RevenueShareRulesetClient.prototype.rulesetSimulatePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__rulesetSimulatePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__rulesetSimulatePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RevenueShareRulesetClient.prototype.__rulesetSimulatePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_223;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/ruleset/simulate')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.productId !== undefined) {
                                qs["productId"] = req.productId;
                            }
                            if (req.amount !== undefined) {
                                qs["amount"] = req.amount.toString();
                            }
                            if (req.currency !== undefined) {
                                qs["currency"] = req.currency;
                            }
                            if (req.sourceAmount !== undefined) {
                                qs["sourceAmount"] = req.sourceAmount.toString();
                            }
                            if (req.sourceCurrency !== undefined) {
                                qs["sourceCurrency"] = req.sourceCurrency;
                            }
                            if (req.decimalPlaces !== undefined) {
                                qs["decimalPlaces"] = req.decimalPlaces.toString();
                            }
                            request.send(JSON.stringify(req.rulesetJson, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_223 = _a.sent();
                            nestedErr = err_223;
                            response = err_223.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return RevenueShareRulesetClient;
    }());
    RevenueShare.RevenueShareRulesetClient = RevenueShareRulesetClient;
    var StripeClient = /** @class */ (function () {
        function StripeClient(apiKey) {
            this.getOriginalApiId = function () { return "revenue-share"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://revenue-share-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        StripeClient.prototype.stripePaymentEnabledPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__stripePaymentEnabledPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__stripePaymentEnabledPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        StripeClient.prototype.__stripePaymentEnabledPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_224;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/stripe/payment/enabled')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.paymentId !== undefined) {
                                qs["paymentId"] = req.paymentId;
                            }
                            if (req.enabled !== undefined) {
                                qs["enabled"] = req.enabled ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_224 = _a.sent();
                            nestedErr = err_224;
                            response = err_224.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        StripeClient.prototype.stripePaymentStatusGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__stripePaymentStatusGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__stripePaymentStatusGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        StripeClient.prototype.__stripePaymentStatusGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_225;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/stripe/payment/status')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.paymentId !== undefined) {
                                qs["paymentId"] = req.paymentId;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_225 = _a.sent();
                            nestedErr = err_225;
                            response = err_225.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        StripeClient.prototype.stripePaymentGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__stripePaymentGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__stripePaymentGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        StripeClient.prototype.__stripePaymentGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_226;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/stripe/payment')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.paymentToken !== undefined) {
                                qs["paymentToken"] = req.paymentToken;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_226 = _a.sent();
                            nestedErr = err_226;
                            response = err_226.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        StripeClient.prototype.stripePaymentPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__stripePaymentPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__stripePaymentPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        StripeClient.prototype.__stripePaymentPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_227;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/stripe/payment')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.paymentToken !== undefined) {
                                qs["paymentToken"] = req.paymentToken;
                            }
                            if (req.stripeToken !== undefined) {
                                qs["stripeToken"] = req.stripeToken;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_227 = _a.sent();
                            nestedErr = err_227;
                            response = err_227.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return StripeClient;
    }());
    RevenueShare.StripeClient = StripeClient;
})(RevenueShare = exports.RevenueShare || (exports.RevenueShare = {}));
var Reporting;
(function (Reporting) {
    var BigQueryAccessClient = /** @class */ (function () {
        function BigQueryAccessClient(apiKey) {
            this.getOriginalApiId = function () { return "reporting"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://reporting-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        BigQueryAccessClient.prototype.bigqueryAccessPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__bigqueryAccessPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__bigqueryAccessPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BigQueryAccessClient.prototype.__bigqueryAccessPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_228;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/bigquery/access')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["accountEmail"] = req.accountEmail;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_228 = _a.sent();
                            nestedErr = err_228;
                            response = err_228.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        BigQueryAccessClient.prototype.bigqueryAccessDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__bigqueryAccessDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__bigqueryAccessDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BigQueryAccessClient.prototype.__bigqueryAccessDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_229;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/bigquery/access')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            qs["accountEmail"] = req.accountEmail;
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_229 = _a.sent();
                            nestedErr = err_229;
                            response = err_229.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        BigQueryAccessClient.prototype.bigqueryProjectAccessGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__bigqueryProjectAccessGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__bigqueryProjectAccessGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BigQueryAccessClient.prototype.__bigqueryProjectAccessGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_230;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/bigquery/project/access')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_230 = _a.sent();
                            nestedErr = err_230;
                            response = err_230.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return BigQueryAccessClient;
    }());
    Reporting.BigQueryAccessClient = BigQueryAccessClient;
    var BuiltinReportsClient = /** @class */ (function () {
        function BuiltinReportsClient(apiKey) {
            this.getOriginalApiId = function () { return "reporting"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://reporting-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        BuiltinReportsClient.prototype.builtinVisitsWishlistsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__builtinVisitsWishlistsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__builtinVisitsWishlistsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.__builtinVisitsWishlistsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_231;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/builtin/visits/wishlists')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start.toString();
                            }
                            if (req.end !== undefined) {
                                qs["end"] = req.end.toString();
                            }
                            if (req.intervalAmount !== undefined) {
                                qs["intervalAmount"] = req.intervalAmount.toString();
                            }
                            if (req.intervalUnits !== undefined) {
                                qs["intervalUnits"] = req.intervalUnits;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_231 = _a.sent();
                            nestedErr = err_231;
                            response = err_231.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.builtinVisitsActionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__builtinVisitsActionsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__builtinVisitsActionsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.__builtinVisitsActionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_232;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/builtin/visits/actions')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start.toString();
                            }
                            if (req.end !== undefined) {
                                qs["end"] = req.end.toString();
                            }
                            if (req.intervalAmount !== undefined) {
                                qs["intervalAmount"] = req.intervalAmount.toString();
                            }
                            if (req.intervalUnits !== undefined) {
                                qs["intervalUnits"] = req.intervalUnits;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_232 = _a.sent();
                            nestedErr = err_232;
                            response = err_232.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.builtinVisitsActionsConversionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__builtinVisitsActionsConversionGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__builtinVisitsActionsConversionGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.__builtinVisitsActionsConversionGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_233;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/builtin/visits/actions/conversion')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start.toString();
                            }
                            if (req.end !== undefined) {
                                qs["end"] = req.end.toString();
                            }
                            if (req.intervalAmount !== undefined) {
                                qs["intervalAmount"] = req.intervalAmount.toString();
                            }
                            if (req.intervalUnits !== undefined) {
                                qs["intervalUnits"] = req.intervalUnits;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_233 = _a.sent();
                            nestedErr = err_233;
                            response = err_233.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.builtinWishlistActionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__builtinWishlistActionsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__builtinWishlistActionsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.__builtinWishlistActionsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_234;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/builtin/wishlist/actions')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start.toString();
                            }
                            if (req.end !== undefined) {
                                qs["end"] = req.end.toString();
                            }
                            if (req.intervalAmount !== undefined) {
                                qs["intervalAmount"] = req.intervalAmount.toString();
                            }
                            if (req.intervalUnits !== undefined) {
                                qs["intervalUnits"] = req.intervalUnits;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_234 = _a.sent();
                            nestedErr = err_234;
                            response = err_234.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.builtinVisitsBreakdownDetailedGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__builtinVisitsBreakdownDetailedGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__builtinVisitsBreakdownDetailedGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.__builtinVisitsBreakdownDetailedGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_235;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/builtin/visits/breakdown/detailed')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start.toString();
                            }
                            if (req.end !== undefined) {
                                qs["end"] = req.end.toString();
                            }
                            if (req.intervalAmount !== undefined) {
                                qs["intervalAmount"] = req.intervalAmount.toString();
                            }
                            if (req.intervalUnits !== undefined) {
                                qs["intervalUnits"] = req.intervalUnits;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_235 = _a.sent();
                            nestedErr = err_235;
                            response = err_235.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.builtinVisitsBreakdownPageGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__builtinVisitsBreakdownPageGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__builtinVisitsBreakdownPageGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.__builtinVisitsBreakdownPageGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_236;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/builtin/visits/breakdown/page')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start.toString();
                            }
                            if (req.end !== undefined) {
                                qs["end"] = req.end.toString();
                            }
                            if (req.intervalAmount !== undefined) {
                                qs["intervalAmount"] = req.intervalAmount.toString();
                            }
                            if (req.intervalUnits !== undefined) {
                                qs["intervalUnits"] = req.intervalUnits;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_236 = _a.sent();
                            nestedErr = err_236;
                            response = err_236.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.builtinSalesUnitBreakdownSourceGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__builtinSalesUnitBreakdownSourceGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__builtinSalesUnitBreakdownSourceGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.__builtinSalesUnitBreakdownSourceGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_237;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/builtin/sales/unit/breakdown/source')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start.toString();
                            }
                            if (req.end !== undefined) {
                                qs["end"] = req.end.toString();
                            }
                            if (req.intervalAmount !== undefined) {
                                qs["intervalAmount"] = req.intervalAmount.toString();
                            }
                            if (req.intervalUnits !== undefined) {
                                qs["intervalUnits"] = req.intervalUnits;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_237 = _a.sent();
                            nestedErr = err_237;
                            response = err_237.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.builtinSalesUnitBreakdownSteamGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__builtinSalesUnitBreakdownSteamGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__builtinSalesUnitBreakdownSteamGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.__builtinSalesUnitBreakdownSteamGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_238;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/builtin/sales/unit/breakdown/steam')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start.toString();
                            }
                            if (req.end !== undefined) {
                                qs["end"] = req.end.toString();
                            }
                            if (req.intervalAmount !== undefined) {
                                qs["intervalAmount"] = req.intervalAmount.toString();
                            }
                            if (req.intervalUnits !== undefined) {
                                qs["intervalUnits"] = req.intervalUnits;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_238 = _a.sent();
                            nestedErr = err_238;
                            response = err_238.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.builtinSalesUnitBreakdownRetailGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__builtinSalesUnitBreakdownRetailGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__builtinSalesUnitBreakdownRetailGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.__builtinSalesUnitBreakdownRetailGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_239;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/builtin/sales/unit/breakdown/retail')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start.toString();
                            }
                            if (req.end !== undefined) {
                                qs["end"] = req.end.toString();
                            }
                            if (req.intervalAmount !== undefined) {
                                qs["intervalAmount"] = req.intervalAmount.toString();
                            }
                            if (req.intervalUnits !== undefined) {
                                qs["intervalUnits"] = req.intervalUnits;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_239 = _a.sent();
                            nestedErr = err_239;
                            response = err_239.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.builtinSalesUsdBreakdownSourceGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__builtinSalesUsdBreakdownSourceGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__builtinSalesUsdBreakdownSourceGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.__builtinSalesUsdBreakdownSourceGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_240;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/builtin/sales/usd/breakdown/source')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start.toString();
                            }
                            if (req.end !== undefined) {
                                qs["end"] = req.end.toString();
                            }
                            if (req.intervalAmount !== undefined) {
                                qs["intervalAmount"] = req.intervalAmount.toString();
                            }
                            if (req.intervalUnits !== undefined) {
                                qs["intervalUnits"] = req.intervalUnits;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_240 = _a.sent();
                            nestedErr = err_240;
                            response = err_240.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.builtinSalesUsdBreakdownSteamGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__builtinSalesUsdBreakdownSteamGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__builtinSalesUsdBreakdownSteamGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        BuiltinReportsClient.prototype.__builtinSalesUsdBreakdownSteamGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_241;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/builtin/sales/usd/breakdown/steam')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start.toString();
                            }
                            if (req.end !== undefined) {
                                qs["end"] = req.end.toString();
                            }
                            if (req.intervalAmount !== undefined) {
                                qs["intervalAmount"] = req.intervalAmount.toString();
                            }
                            if (req.intervalUnits !== undefined) {
                                qs["intervalUnits"] = req.intervalUnits;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_241 = _a.sent();
                            nestedErr = err_241;
                            response = err_241.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return BuiltinReportsClient;
    }());
    Reporting.BuiltinReportsClient = BuiltinReportsClient;
    var ReportClient = /** @class */ (function () {
        function ReportClient(apiKey) {
            this.getOriginalApiId = function () { return "reporting"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://reporting-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        ReportClient.prototype.reportsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__reportsGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__reportsGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ReportClient.prototype.__reportsGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_242;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/reports')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_242 = _a.sent();
                            nestedErr = err_242;
                            response = err_242.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ReportClient.prototype.reportGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__reportGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__reportGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ReportClient.prototype.__reportGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_243;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/report')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            if (req.start !== undefined) {
                                qs["start"] = req.start.toString();
                            }
                            if (req.end !== undefined) {
                                qs["end"] = req.end.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_243 = _a.sent();
                            nestedErr = err_243;
                            response = err_243.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ReportClient.prototype.reportMetadataGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__reportMetadataGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__reportMetadataGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ReportClient.prototype.__reportMetadataGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_244;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/report/metadata')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_244 = _a.sent();
                            nestedErr = err_244;
                            response = err_244.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ReportClient.prototype.reportRunPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__reportRunPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__reportRunPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        ReportClient.prototype.__reportRunPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_245;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/report/run')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            if (req.disableCache !== undefined) {
                                qs["disableCache"] = req.disableCache ? "true" : "false";
                            }
                            request.send(JSON.stringify(req.arguments, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_245 = _a.sent();
                            nestedErr = err_245;
                            response = err_245.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return ReportClient;
    }());
    Reporting.ReportClient = ReportClient;
})(Reporting = exports.Reporting || (exports.Reporting = {}));
var GameServer;
(function (GameServer) {
    var GameServerClient = /** @class */ (function () {
        function GameServerClient(apiKey) {
            this.getOriginalApiId = function () { return "game-server"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://game-server-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        GameServerClient.prototype.serversGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__serversGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__serversGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerClient.prototype.__serversGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_246;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/servers')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_246 = _a.sent();
                            nestedErr = err_246;
                            response = err_246.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerClient.prototype.serverGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__serverGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__serverGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerClient.prototype.__serverGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_247;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/server')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_247 = _a.sent();
                            nestedErr = err_247;
                            response = err_247.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerClient.prototype.serverPublicGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__serverPublicGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__serverPublicGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerClient.prototype.__serverPublicGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_248;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/server/public')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_248 = _a.sent();
                            nestedErr = err_248;
                            response = err_248.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerClient.prototype.terminateDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__terminateDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__terminateDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerClient.prototype.__terminateDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_249;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/terminate')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_249 = _a.sent();
                            nestedErr = err_249;
                            response = err_249.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerClient.prototype.provisionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__provisionPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__provisionPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerClient.prototype.__provisionPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_250;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/provision')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.provisioningRequest, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_250 = _a.sent();
                            nestedErr = err_250;
                            response = err_250.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return GameServerClient;
    }());
    GameServer.GameServerClient = GameServerClient;
    var GameServerClusterClient = /** @class */ (function () {
        function GameServerClusterClient(apiKey) {
            this.getOriginalApiId = function () { return "game-server"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://game-server-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        GameServerClusterClient.prototype.clustersGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__clustersGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__clustersGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerClusterClient.prototype.__clustersGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_251;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/clusters')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            if (req.showHidden !== undefined) {
                                qs["showHidden"] = req.showHidden ? "true" : "false";
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_251 = _a.sent();
                            nestedErr = err_251;
                            response = err_251.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerClusterClient.prototype.clustersSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__clustersSearchGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__clustersSearchGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerClusterClient.prototype.__clustersSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_252;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/clusters/search')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.text !== undefined) {
                                qs["text"] = req.text;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_252 = _a.sent();
                            nestedErr = err_252;
                            response = err_252.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerClusterClient.prototype.clusterGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__clusterGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__clusterGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerClusterClient.prototype.__clusterGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_253;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/cluster')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_253 = _a.sent();
                            nestedErr = err_253;
                            response = err_253.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerClusterClient.prototype.clusterPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__clusterPUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__clusterPUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerClusterClient.prototype.__clusterPUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_254;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/cluster')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.cluster, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_254 = _a.sent();
                            nestedErr = err_254;
                            response = err_254.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerClusterClient.prototype.clusterPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__clusterPOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__clusterPOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerClusterClient.prototype.__clusterPOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_255;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/cluster')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.cluster, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_255 = _a.sent();
                            nestedErr = err_255;
                            response = err_255.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerClusterClient.prototype.clusterDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__clusterDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__clusterDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerClusterClient.prototype.__clusterDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_256;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/cluster')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_256 = _a.sent();
                            nestedErr = err_256;
                            response = err_256.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return GameServerClusterClient;
    }());
    GameServer.GameServerClusterClient = GameServerClusterClient;
    var GameServerNotifyClient = /** @class */ (function () {
        function GameServerNotifyClient(apiKey) {
            this.getOriginalApiId = function () { return "game-server"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://game-server-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        GameServerNotifyClient.prototype.kubernetesNotifyGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__kubernetesNotifyGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__kubernetesNotifyGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerNotifyClient.prototype.__kubernetesNotifyGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_257;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/kubernetes/notify')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.projectId !== undefined) {
                                qs["projectId"] = req.projectId;
                            }
                            if (req.clusterId !== undefined) {
                                qs["clusterId"] = req.clusterId;
                            }
                            if (req.clusterSecretToken !== undefined) {
                                qs["clusterSecretToken"] = req.clusterSecretToken;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_257 = _a.sent();
                            nestedErr = err_257;
                            response = err_257.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return GameServerNotifyClient;
    }());
    GameServer.GameServerNotifyClient = GameServerNotifyClient;
    var GameServerTemplateClient = /** @class */ (function () {
        function GameServerTemplateClient(apiKey) {
            this.getOriginalApiId = function () { return "game-server"; };
            this.getOriginalBasePath = function () { return "/v1"; };
            if (apiKey === undefined) {
                this.apiKeyFactory = function () { return ''; };
            }
            else if (typeof apiKey === 'string') {
                this.apiKeyFactory = function () { return apiKey; };
            }
            else {
                this.apiKeyFactory = apiKey;
            }
            this.baseUrlFactory = function () { return "https://game-server-api.hivemp.com/v1"; };
            this.invocationWrapper = null;
        }
        GameServerTemplateClient.prototype.templatesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__templatesGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__templatesGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerTemplateClient.prototype.__templatesGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_258;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/templates')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.start !== undefined) {
                                qs["start"] = req.start;
                            }
                            if (req.limit !== undefined) {
                                qs["limit"] = req.limit.toString();
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_258 = _a.sent();
                            nestedErr = err_258;
                            response = err_258.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerTemplateClient.prototype.templatesSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__templatesSearchGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__templatesSearchGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerTemplateClient.prototype.__templatesSearchGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_259;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/templates/search')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.text !== undefined) {
                                qs["text"] = req.text;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_259 = _a.sent();
                            nestedErr = err_259;
                            response = err_259.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerTemplateClient.prototype.templateGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__templateGET(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__templateGET(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerTemplateClient.prototype.__templateGET = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_260;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .get(this.baseUrlFactory() + '/template')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_260 = _a.sent();
                            nestedErr = err_260;
                            response = err_260.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerTemplateClient.prototype.templatePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__templatePUT(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__templatePUT(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerTemplateClient.prototype.__templatePUT = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_261;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .put(this.baseUrlFactory() + '/template')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.template, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_261 = _a.sent();
                            nestedErr = err_261;
                            response = err_261.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerTemplateClient.prototype.templatePOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__templatePOST(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__templatePOST(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerTemplateClient.prototype.__templatePOST = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_262;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .post(this.baseUrlFactory() + '/template')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            request.send(JSON.stringify(req.template, replaceValue));
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_262 = _a.sent();
                            nestedErr = err_262;
                            response = err_262.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        GameServerTemplateClient.prototype.templateDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.invocationWrapper === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.__templateDELETE(req)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, this.invocationWrapper(function () { return _this.__templateDELETE(req); })];
                        case 3: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        GameServerTemplateClient.prototype.__templateDELETE = function (req) {
            return __awaiter(this, void 0, void 0, function () {
                var request, qs, response, nestedErr, err_263;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            request = superagent
                                .del(this.baseUrlFactory() + '/template')
                                .set('Content-Type', 'application/json');
                            qs = {};
                            if (req.id !== undefined) {
                                qs["id"] = req.id;
                            }
                            request.query(qs);
                            request.set('X-API-Key', this.apiKeyFactory());
                            response = null;
                            nestedErr = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, request];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_263 = _a.sent();
                            nestedErr = err_263;
                            response = err_263.response;
                            return [3 /*break*/, 4];
                        case 4:
                            if (response !== undefined && response !== null && response.ok) {
                                return [2 /*return*/, JSON.parse(response.text, reviveValue)];
                            }
                            else {
                                if (response === undefined || response === null) {
                                    throw HiveMPErrorFactory.createUnknownError(nestedErr);
                                }
                                else if (response.serverError || response.clientError) {
                                    throw HiveMPErrorFactory.createApiError(JSON.parse(response.text, reviveValue));
                                }
                                else {
                                    throw HiveMPErrorFactory.createClientError(response);
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return GameServerTemplateClient;
    }());
    GameServer.GameServerTemplateClient = GameServerTemplateClient;
})(GameServer = exports.GameServer || (exports.GameServer = {}));
//# sourceMappingURL=index.js.map